/* nefunc.h: this header file was produced automatically by
 * the ./mktbls program, based on input from the file ./cmdtbl
 */

#ifdef real_CMDFUNCS

	DECL_EXTERN_CONST(CMDFUNC f_abbrev) = {
	INIT_UNION(abbrev),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"abbrev"
#endif
#if OPT_ONLINEHELP
		,"establish shorthand for another string, or show all abbreviations"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_altbuff) = {
	INIT_UNION(altbuff),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"altbuff"
#endif
#if OPT_ONLINEHELP
		,"switch to previous buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_append) = {
	INIT_UNION(append),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"append"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) text after the cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_append_i) = {
	INIT_UNION(append_i),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"append_i"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) text after the cursor, toggles autoindent"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_appstring) = {
	INIT_UNION(appstring),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"appstring"
#endif
#if OPT_ONLINEHELP
		,"append (CNT copies of) the given string after the cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_appnumber) = {
	INIT_UNION(appnumber),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"appnumber"
#endif
#if OPT_ONLINEHELP
		,"append (CNT copies of) the given character-number after the cursor"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_appendeol) = {
	INIT_UNION(appendeol),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"appendeol"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) text after the end of line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backchar) = {
	INIT_UNION(backchar),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backchar"
#endif
#if OPT_ONLINEHELP
		,"move CNT characters left, wrapping to previous line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backchar_to_bol) = {
	INIT_UNION(backchar_to_bol),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backchar_to_bol"
#endif
#if OPT_ONLINEHELP
		,"move CNT characters left, stopping at beginning of line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backdelchar) = {
	INIT_UNION(backdelchar),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backdelchar"
#endif
#if OPT_ONLINEHELP
		,"delete CNT characters to the left"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_backhunt) = {
	INIT_UNION(backhunt),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backhunt"
#endif
#if OPT_ONLINEHELP
		,"search backward for CNT'th occurrence of previously entered pattern"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_backhpage) = {
	INIT_UNION(backhpage),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backhpage"
#endif
#if OPT_ONLINEHELP
		,"move up CNT half screens"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backline) = {
	INIT_UNION(backline),
	GOAL|MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backline"
#endif
#if OPT_ONLINEHELP
		,"move up CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backbline) = {
	INIT_UNION(backbline),
	MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backbline"
#endif
#if OPT_ONLINEHELP
		,"move up CNT lines, to first non-white character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backpage) = {
	INIT_UNION(backpage),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backpage"
#endif
#if OPT_ONLINEHELP
		,"move up CNT full screens"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_back_row) = {
	INIT_UNION(back_row),
	GOAL|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"back_row"
#endif
#if OPT_ONLINEHELP
		,"move up CNT rows on the screen"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backword) = {
	INIT_UNION(backword),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backword"
#endif
#if OPT_ONLINEHELP
		,"move left by CNT \"big\" words"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backviword) = {
	INIT_UNION(backviword),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backviword"
#endif
#if OPT_ONLINEHELP
		,"move left by CNT \"small\" words"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backsearch) = {
	INIT_UNION(backsearch),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backsearch"
#endif
#if OPT_ONLINEHELP
		,"search backwards for fresh pattern"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_bcsrch) = {
	INIT_UNION(bcsrch),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bcsrch"
#endif
#if OPT_ONLINEHELP
		,"scan left on the line for CNT'th occurrence of the given character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_bcsrch_to) = {
	INIT_UNION(bcsrch_to),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bcsrch_to"
#endif
#if OPT_ONLINEHELP
		,"scan left on the line up to but not including CNT'th occurrence of the given character"
#endif
 };
#if OPT_REBIND
	DECL_EXTERN_CONST(CMDFUNC f_bindkey) = {
	INIT_UNION(bindkey),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bindkey"
#endif
#if OPT_ONLINEHELP
		,"bind a keystroke to a function"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_bind_i_key) = {
	INIT_UNION(bind_i_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bind_i_key"
#endif
#if OPT_ONLINEHELP
		,"bind a keystroke to a function effective in insertion mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_bind_c_key) = {
	INIT_UNION(bind_c_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bind_c_key"
#endif
#if OPT_ONLINEHELP
		,"bind a keystroke to a function effective in command mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_bind_s_key) = {
	INIT_UNION(bind_s_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bind_s_key"
#endif
#if OPT_ONLINEHELP
		,"bind a keystroke to a function effective in select mode"
#endif
 };
#endif
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_bktoshell) = {
	INIT_UNION(bktoshell),
	BANG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"bktoshell"
#endif
#if OPT_ONLINEHELP
		,"suspend the editor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_chdir) = {
	INIT_UNION(vl_chdir),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_chdir"
#endif
#if OPT_ONLINEHELP
		,"move to a new directory, \"-\" is previous, \"~\" is $HOME"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_cntl_x_func) = {
	INIT_UNION(cntl_x_func),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cntl_x_func"
#endif
#if OPT_ONLINEHELP
		,"the \"Control-X\" prefix, used when typing extended commands"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_chgchar) = {
	INIT_UNION(chgchar),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"chgchar"
#endif
#if OPT_ONLINEHELP
		,"insert text to replace CNT characters"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_chgline) = {
	INIT_UNION(chgline),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"chgline"
#endif
#if OPT_ONLINEHELP
		,"insert text to replace the CNT lines, starting with current line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_chgtoeol) = {
	INIT_UNION(chgtoeol),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"chgtoeol"
#endif
#if OPT_ONLINEHELP
		,"insert text to replace the rest of the line (plus CNT-1 following)"
#endif
 };
#if OPT_HILITEMATCH
	DECL_EXTERN_CONST(CMDFUNC f_clear_match_attrs) = {
	INIT_UNION(clear_match_attrs),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"clear_match_attrs"
#endif
#if OPT_ONLINEHELP
		,"clear highlighting caused by searches when \"visual-matches\" is set"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_clrmes) = {
	INIT_UNION(clrmes),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"clrmes"
#endif
#if OPT_ONLINEHELP
		,"erase text on the bottom line of screen"
#endif
 };
#if OPT_FINDERR
	DECL_EXTERN_CONST(CMDFUNC f_comp_err_exps) = {
	INIT_UNION(comp_err_exps),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"comp_err_exps"
#endif
#if OPT_ONLINEHELP
		,"(re)compile the [Error Expressions] buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_show_err_regex) = {
	INIT_UNION(show_err_regex),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"show_err_regex"
#endif
#if OPT_ONLINEHELP
		,"display error meta-expressions and resulting regular expressions"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_consearch) = {
	INIT_UNION(consearch),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"consearch"
#endif
#if OPT_ONLINEHELP
		,"search for previous pattern in same direction as before, CNT'th occurrence"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opercopy) = {
	INIT_UNION(opercopy),
	OPER|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opercopy"
#endif
#if OPT_ONLINEHELP
		,"copy text in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_kbd_mac_startstop) = {
	INIT_UNION(kbd_mac_startstop),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"kbd_mac_startstop"
#endif
#if OPT_ONLINEHELP
		,"begin or end recording a macro of keystrokes"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_kbd_mac_exec) = {
	INIT_UNION(kbd_mac_exec),
	REDO|UNDO|VIEWOK
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"kbd_mac_exec"
#endif
#if OPT_ONLINEHELP
		,"execute a previously recorded macro of keystrokes CNT times"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_kbd_mac_save) = {
	INIT_UNION(kbd_mac_save),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"kbd_mac_save"
#endif
#if OPT_ONLINEHELP
		,"save a previously recorded macro of keystrokes to a named register"
#endif
 };
#if OPT_EXEC_MACROS>0
	DECL_EXTERN_CONST(CMDFUNC f_cbuf1) = {
	INIT_UNION(cbuf1),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf1"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 1] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>1
	DECL_EXTERN_CONST(CMDFUNC f_cbuf2) = {
	INIT_UNION(cbuf2),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf2"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 2] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>2
	DECL_EXTERN_CONST(CMDFUNC f_cbuf3) = {
	INIT_UNION(cbuf3),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf3"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 3] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>3
	DECL_EXTERN_CONST(CMDFUNC f_cbuf4) = {
	INIT_UNION(cbuf4),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf4"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 4] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>4
	DECL_EXTERN_CONST(CMDFUNC f_cbuf5) = {
	INIT_UNION(cbuf5),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf5"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 5] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>5
	DECL_EXTERN_CONST(CMDFUNC f_cbuf6) = {
	INIT_UNION(cbuf6),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf6"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 6] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>6
	DECL_EXTERN_CONST(CMDFUNC f_cbuf7) = {
	INIT_UNION(cbuf7),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf7"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 7] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>7
	DECL_EXTERN_CONST(CMDFUNC f_cbuf8) = {
	INIT_UNION(cbuf8),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf8"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 8] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>8
	DECL_EXTERN_CONST(CMDFUNC f_cbuf9) = {
	INIT_UNION(cbuf9),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf9"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 9] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>9
	DECL_EXTERN_CONST(CMDFUNC f_cbuf10) = {
	INIT_UNION(cbuf10),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf10"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 10] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>10
	DECL_EXTERN_CONST(CMDFUNC f_cbuf11) = {
	INIT_UNION(cbuf11),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf11"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 11] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>11
	DECL_EXTERN_CONST(CMDFUNC f_cbuf12) = {
	INIT_UNION(cbuf12),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf12"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 12] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>12
	DECL_EXTERN_CONST(CMDFUNC f_cbuf13) = {
	INIT_UNION(cbuf13),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf13"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 13] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>13
	DECL_EXTERN_CONST(CMDFUNC f_cbuf14) = {
	INIT_UNION(cbuf14),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf14"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 14] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>14
	DECL_EXTERN_CONST(CMDFUNC f_cbuf15) = {
	INIT_UNION(cbuf15),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf15"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 15] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>15
	DECL_EXTERN_CONST(CMDFUNC f_cbuf16) = {
	INIT_UNION(cbuf16),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf16"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 16] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>16
	DECL_EXTERN_CONST(CMDFUNC f_cbuf17) = {
	INIT_UNION(cbuf17),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf17"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 17] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>17
	DECL_EXTERN_CONST(CMDFUNC f_cbuf18) = {
	INIT_UNION(cbuf18),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf18"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 18] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>18
	DECL_EXTERN_CONST(CMDFUNC f_cbuf19) = {
	INIT_UNION(cbuf19),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf19"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 19] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>19
	DECL_EXTERN_CONST(CMDFUNC f_cbuf20) = {
	INIT_UNION(cbuf20),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf20"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 20] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>20
	DECL_EXTERN_CONST(CMDFUNC f_cbuf21) = {
	INIT_UNION(cbuf21),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf21"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 21] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>21
	DECL_EXTERN_CONST(CMDFUNC f_cbuf22) = {
	INIT_UNION(cbuf22),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf22"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 22] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>22
	DECL_EXTERN_CONST(CMDFUNC f_cbuf23) = {
	INIT_UNION(cbuf23),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf23"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 23] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>23
	DECL_EXTERN_CONST(CMDFUNC f_cbuf24) = {
	INIT_UNION(cbuf24),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf24"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 24] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>24
	DECL_EXTERN_CONST(CMDFUNC f_cbuf25) = {
	INIT_UNION(cbuf25),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf25"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 25] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>25
	DECL_EXTERN_CONST(CMDFUNC f_cbuf26) = {
	INIT_UNION(cbuf26),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf26"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 26] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>26
	DECL_EXTERN_CONST(CMDFUNC f_cbuf27) = {
	INIT_UNION(cbuf27),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf27"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 27] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>27
	DECL_EXTERN_CONST(CMDFUNC f_cbuf28) = {
	INIT_UNION(cbuf28),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf28"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 28] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>28
	DECL_EXTERN_CONST(CMDFUNC f_cbuf29) = {
	INIT_UNION(cbuf29),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf29"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 29] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>29
	DECL_EXTERN_CONST(CMDFUNC f_cbuf30) = {
	INIT_UNION(cbuf30),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf30"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 30] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>30
	DECL_EXTERN_CONST(CMDFUNC f_cbuf31) = {
	INIT_UNION(cbuf31),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf31"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 31] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>31
	DECL_EXTERN_CONST(CMDFUNC f_cbuf32) = {
	INIT_UNION(cbuf32),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf32"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 32] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>32
	DECL_EXTERN_CONST(CMDFUNC f_cbuf33) = {
	INIT_UNION(cbuf33),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf33"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 33] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>33
	DECL_EXTERN_CONST(CMDFUNC f_cbuf34) = {
	INIT_UNION(cbuf34),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf34"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 34] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>34
	DECL_EXTERN_CONST(CMDFUNC f_cbuf35) = {
	INIT_UNION(cbuf35),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf35"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 35] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>35
	DECL_EXTERN_CONST(CMDFUNC f_cbuf36) = {
	INIT_UNION(cbuf36),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf36"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 36] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>36
	DECL_EXTERN_CONST(CMDFUNC f_cbuf37) = {
	INIT_UNION(cbuf37),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf37"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 37] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>37
	DECL_EXTERN_CONST(CMDFUNC f_cbuf38) = {
	INIT_UNION(cbuf38),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf38"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 38] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>38
	DECL_EXTERN_CONST(CMDFUNC f_cbuf39) = {
	INIT_UNION(cbuf39),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf39"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 39] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>39
	DECL_EXTERN_CONST(CMDFUNC f_cbuf40) = {
	INIT_UNION(cbuf40),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf40"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 40] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>40
	DECL_EXTERN_CONST(CMDFUNC f_cbuf41) = {
	INIT_UNION(cbuf41),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf41"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 41] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>41
	DECL_EXTERN_CONST(CMDFUNC f_cbuf42) = {
	INIT_UNION(cbuf42),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf42"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 42] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>42
	DECL_EXTERN_CONST(CMDFUNC f_cbuf43) = {
	INIT_UNION(cbuf43),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf43"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 43] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>43
	DECL_EXTERN_CONST(CMDFUNC f_cbuf44) = {
	INIT_UNION(cbuf44),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf44"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 44] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>44
	DECL_EXTERN_CONST(CMDFUNC f_cbuf45) = {
	INIT_UNION(cbuf45),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf45"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 45] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>45
	DECL_EXTERN_CONST(CMDFUNC f_cbuf46) = {
	INIT_UNION(cbuf46),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf46"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 46] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>46
	DECL_EXTERN_CONST(CMDFUNC f_cbuf47) = {
	INIT_UNION(cbuf47),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf47"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 47] CNT times"
#endif
 };
#endif
#if OPT_EXEC_MACROS>47
	DECL_EXTERN_CONST(CMDFUNC f_cbuf48) = {
	INIT_UNION(cbuf48),
	REDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbuf48"
#endif
#if OPT_ONLINEHELP
		,"execute [Macro 48] CNT times"
#endif
 };
#endif
#if OPT_MAJORMODE
	DECL_EXTERN_CONST(CMDFUNC f_define_mode) = {
	INIT_UNION(define_mode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"define_mode"
#endif
#if OPT_ONLINEHELP
		,"define a major mode, i.e., a collection of buffer modes"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_define_submode) = {
	INIT_UNION(define_submode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"define_submode"
#endif
#if OPT_ONLINEHELP
		,"define a submode within a major mode"
#endif
 };
#endif
#if OPT_COLOR_SCHEMES
	DECL_EXTERN_CONST(CMDFUNC f_define_scheme) = {
	INIT_UNION(define_scheme),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"define_scheme"
#endif
#if OPT_ONLINEHELP
		,"define a color scheme"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_delwind) = {
	INIT_UNION(delwind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"delwind"
#endif
#if OPT_ONLINEHELP
		,"destroy the current window, unless it is the last one"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forceblank) = {
	INIT_UNION(forceblank),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forceblank"
#endif
#if OPT_ONLINEHELP
		,"delete blank lines (or force some if CNT specified)"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_delglobmode) = {
	INIT_UNION(delglobmode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"delglobmode"
#endif
#if OPT_ONLINEHELP
		,"turn off the global value of a mode setting"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_dellocmode) = {
	INIT_UNION(dellocmode),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"dellocmode"
#endif
#if OPT_ONLINEHELP
		,"turn off the current buffer's local value of a mode setting"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_deltoeol) = {
	INIT_UNION(deltoeol),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"deltoeol"
#endif
#if OPT_ONLINEHELP
		,"delete text from cursor to the end of line"
#endif
 };
#if OPT_REBIND
	DECL_EXTERN_CONST(CMDFUNC f_desbind) = {
	INIT_UNION(desbind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"desbind"
#endif
#if OPT_ONLINEHELP
		,"show a list of all commands"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_i_bind) = {
	INIT_UNION(des_i_bind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_i_bind"
#endif
#if OPT_ONLINEHELP
		,"show a list of all commands that may be executed in insert-mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_c_bind) = {
	INIT_UNION(des_c_bind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_c_bind"
#endif
#if OPT_ONLINEHELP
		,"show a list of all commands that may be executed in command-editing mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_s_bind) = {
	INIT_UNION(des_s_bind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_s_bind"
#endif
#if OPT_ONLINEHELP
		,"show a list of all commands that may be executed in selection mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_keynames) = {
	INIT_UNION(des_keynames),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_keynames"
#endif
#if OPT_ONLINEHELP
		,"show a list of all function-key that may be bound with #-syntax"
#endif
 };
#endif
#if OPT_SHOW_COLORS
	DECL_EXTERN_CONST(CMDFUNC f_descolors) = {
	INIT_UNION(descolors),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"descolors"
#endif
#if OPT_ONLINEHELP
		,"show a list of all colors, as mapped by $palette"
#endif
 };
#endif
#if OPT_REBIND
	DECL_EXTERN_CONST(CMDFUNC f_desmotions) = {
	INIT_UNION(desmotions),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"desmotions"
#endif
#if OPT_ONLINEHELP
		,"show a list of all motion commands"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_desopers) = {
	INIT_UNION(desopers),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"desopers"
#endif
#if OPT_ONLINEHELP
		,"show a list of all operator commands"
#endif
 };
#endif
#if OPT_COLOR_SCHEMES
	DECL_EXTERN_CONST(CMDFUNC f_desschemes) = {
	INIT_UNION(desschemes),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"desschemes"
#endif
#if OPT_ONLINEHELP
		,"show the color scheme parameters"
#endif
 };
#endif
#if OPT_SHOW_CTYPE
	DECL_EXTERN_CONST(CMDFUNC f_desprint) = {
	INIT_UNION(desprint),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"desprint"
#endif
#if OPT_ONLINEHELP
		,"show the printable characters, with types"
#endif
 };
#endif
#if OPT_REBIND
	DECL_EXTERN_CONST(CMDFUNC f_dessubstr) = {
	INIT_UNION(dessubstr),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"dessubstr"
#endif
#if OPT_ONLINEHELP
		,"look up command names containing a string"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_desfunc) = {
	INIT_UNION(desfunc),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"desfunc"
#endif
#if OPT_ONLINEHELP
		,"show a description and current bindings for a function"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_deskey) = {
	INIT_UNION(deskey),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"deskey"
#endif
#if OPT_ONLINEHELP
		,"show the function bound to a given key"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_i_key) = {
	INIT_UNION(des_i_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_i_key"
#endif
#if OPT_ONLINEHELP
		,"show the function bound to a given key in insert-mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_c_key) = {
	INIT_UNION(des_c_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_c_key"
#endif
#if OPT_ONLINEHELP
		,"show the function bound to a given key in command-mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_s_key) = {
	INIT_UNION(des_s_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_s_key"
#endif
#if OPT_ONLINEHELP
		,"show the function bound to a given key in selection-mode"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_dotcmdplay) = {
	INIT_UNION(dotcmdplay),
	UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"dotcmdplay"
#endif
#if OPT_ONLINEHELP
		,"repeat the last text-changing command, CNT times"
#endif
 };
#if OPT_EVAL
	DECL_EXTERN_CONST(CMDFUNC f_des_amp_funcs) = {
	INIT_UNION(des_amp_funcs),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_amp_funcs"
#endif
#if OPT_ONLINEHELP
		,""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_des_dlr_vars) = {
	INIT_UNION(des_dlr_vars),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"des_dlr_vars"
#endif
#if OPT_ONLINEHELP
		,""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_evaluate) = {
	INIT_UNION(evaluate),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"evaluate"
#endif
#if OPT_ONLINEHELP
		,"evaluate expression, reinterpret as a command (CNT as per command)"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_ex) = {
	INIT_UNION(ex),
	BANG|FILE1
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"ex"
#endif
#if OPT_ONLINEHELP
		,"entry point to the \"exile\" editor.  unimplemented"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_execbuf) = {
	INIT_UNION(execbuf),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"execbuf"
#endif
#if OPT_ONLINEHELP
		,"run the given buffer as a script, CNT times"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_execfile) = {
	INIT_UNION(execfile),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"execfile"
#endif
#if OPT_ONLINEHELP
		,"run the given file as a script, CNT times"
#endif
 };
#if OPT_HYPERTEXT
	DECL_EXTERN_CONST(CMDFUNC f_exechypercmd) = {
	INIT_UNION(exechypercmd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"exechypercmd"
#endif
#if OPT_ONLINEHELP
		,"run the hypertext command attached to the region under the cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_showhypercmd) = {
	INIT_UNION(showhypercmd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showhypercmd"
#endif
#if OPT_ONLINEHELP
		,"show the hypertext command attached to the region under the cursor"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_execkreg) = {
	INIT_UNION(execkreg),
	REDO|UNDO|VIEWOK|USEREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"execkreg"
#endif
#if OPT_ONLINEHELP
		,"execute the keystroke macro stored in the given named register CNT times"
#endif
 };
#if OPT_PROCEDURES
	DECL_EXTERN_CONST(CMDFUNC f_execproc) = {
	INIT_UNION(execproc),
	REDO|EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"execproc"
#endif
#if OPT_ONLINEHELP
		,"run the given named stored-procedure as a script, CNT times"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_enlargewind) = {
	INIT_UNION(enlargewind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"enlargewind"
#endif
#if OPT_ONLINEHELP
		,"increase the size of the current window by CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_esc_func) = {
	INIT_UNION(esc_func),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"esc_func"
#endif
#if OPT_ONLINEHELP
		,"the abort key, normally bound to ESC; it terminates lots of things"
#endif
 };
#if SYS_UNIX
	DECL_EXTERN_CONST(CMDFUNC f_flow_control_enable) = {
	INIT_UNION(flow_control_enable),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"flow_control_enable"
#endif
#if OPT_ONLINEHELP
		,"enable software flow-control (disable with arg)"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_fcsrch) = {
	INIT_UNION(fcsrch),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"fcsrch"
#endif
#if OPT_ONLINEHELP
		,"scan right on the line for (CNT'th occurrence of) the given character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_fcsrch_to) = {
	INIT_UNION(fcsrch_to),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"fcsrch_to"
#endif
#if OPT_ONLINEHELP
		,"scan right on the line up to but not including (CNT'th occurrence of) the given character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_filefind) = {
	INIT_UNION(filefind),
	BANG|FILE1|PLUS
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"filefind"
#endif
#if OPT_ONLINEHELP
		,"bring given (or under-cursor) file or existing buffer into window"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_fileread) = {
	INIT_UNION(fileread),
	EXRCOK|FILE1
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"fileread"
#endif
#if OPT_ONLINEHELP
		,"replace the contents of the current buffer with the given file"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_filename) = {
	INIT_UNION(vl_filename),
	NAMEDF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_filename"
#endif
#if OPT_ONLINEHELP
		,"change the filename associated with the current buffer"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_filesave) = {
	INIT_UNION(filesave),
	BANG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"filesave"
#endif
#if OPT_ONLINEHELP
		,"save the contents of the current buffer to its associated filename"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_filewrite) = {
	INIT_UNION(filewrite),
	BANG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"filewrite"
#endif
#if OPT_ONLINEHELP
		,"syntax: \"write-file [name]\" - write contents of current buffer to its filename or to optional \"name\""
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_vile_filter) = {
	INIT_UNION(vile_filter),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vile_filter"
#endif
#if OPT_ONLINEHELP
		,"pipe the entire buffer through an external filter command"
#endif
 };
#endif
#if OPT_FINDERR
	DECL_EXTERN_CONST(CMDFUNC f_finderr) = {
	INIT_UNION(finderr),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"finderr"
#endif
#if OPT_ONLINEHELP
		,"move to the next \"error\" in the error-buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_finderrbuf) = {
	INIT_UNION(finderrbuf),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"finderrbuf"
#endif
#if OPT_ONLINEHELP
		,"set the name of the buffer used as the error-buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_firstbuffer) = {
	INIT_UNION(firstbuffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"firstbuffer"
#endif
#if OPT_ONLINEHELP
		,"go to first buffer in buffer list"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_firstnonwhite) = {
	INIT_UNION(firstnonwhite),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"firstnonwhite"
#endif
#if OPT_ONLINEHELP
		,"move to the first non-whitespace character on line"
#endif
 };
#if OPT_ISRCH
	DECL_EXTERN_CONST(CMDFUNC f_fisearch) = {
	INIT_UNION(fisearch),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"fisearch"
#endif
#if OPT_ONLINEHELP
		,"search forward for a pattern entered character by character"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_flipchar) = {
	INIT_UNION(flipchar),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"flipchar"
#endif
#if OPT_ONLINEHELP
		,"exchange upper and lowercase for CNT characters, begin with current"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwdelchar) = {
	INIT_UNION(forwdelchar),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwdelchar"
#endif
#if OPT_ONLINEHELP
		,"delete CNT characters to the right"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwhpage) = {
	INIT_UNION(forwhpage),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwhpage"
#endif
#if OPT_ONLINEHELP
		,"move down CNT half screens"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwchar) = {
	INIT_UNION(forwchar),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwchar"
#endif
#if OPT_ONLINEHELP
		,"move CNT characters right, wrapping to next line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwchar_to_eol) = {
	INIT_UNION(forwchar_to_eol),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwchar_to_eol"
#endif
#if OPT_ONLINEHELP
		,"move CNT characters right, stopping at end of line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwpage) = {
	INIT_UNION(forwpage),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwpage"
#endif
#if OPT_ONLINEHELP
		,"move down CNT full screens"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forw_row) = {
	INIT_UNION(forw_row),
	GOAL|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forw_row"
#endif
#if OPT_ONLINEHELP
		,"move down CNT rows on the screen"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwline) = {
	INIT_UNION(forwline),
	GOAL|MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwline"
#endif
#if OPT_ONLINEHELP
		,"move down CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwbline) = {
	INIT_UNION(forwbline),
	MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwbline"
#endif
#if OPT_ONLINEHELP
		,"move down CNT lines, to first non-white character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwword) = {
	INIT_UNION(forwword),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwword"
#endif
#if OPT_ONLINEHELP
		,"move right by CNT \"big\" words"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwviword) = {
	INIT_UNION(forwviword),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwviword"
#endif
#if OPT_ONLINEHELP
		,"move right by CNT \"small\" words"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwendw) = {
	INIT_UNION(forwendw),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwendw"
#endif
#if OPT_ONLINEHELP
		,"move right to the end of CNT \"big\" words"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwviendw) = {
	INIT_UNION(forwviendw),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwviendw"
#endif
#if OPT_ONLINEHELP
		,"move right to the end of CNT \"small\" words"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_forwhunt) = {
	INIT_UNION(forwhunt),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwhunt"
#endif
#if OPT_ONLINEHELP
		,"search forward for CNT'th occurrence of previously entered pattern"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_forwsearch) = {
	INIT_UNION(forwsearch),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwsearch"
#endif
#if OPT_ONLINEHELP
		,"search forward for CNT'th occurrence of fresh $identifier pattern"
#endif
 };
#if OPT_CFENCE
	DECL_EXTERN_CONST(CMDFUNC f_matchfence) = {
	INIT_UNION(matchfence),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"matchfence"
#endif
#if OPT_ONLINEHELP
		,"find partner for next (,),[,],{,},#if,#else,#endif,/*,*/"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_matchfenceback) = {
	INIT_UNION(matchfenceback),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"matchfenceback"
#endif
#if OPT_ONLINEHELP
		,"find partner for previous (,),[,],{,} on line"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_globals) = {
	INIT_UNION(globals),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"globals"
#endif
#if OPT_ONLINEHELP
		,""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_godotplus) = {
	INIT_UNION(godotplus),
	MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"godotplus"
#endif
#if OPT_ONLINEHELP
		,"move CNT whole lines.  same as \"stuttering\" most operators"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gomark) = {
	INIT_UNION(gomark),
	MOTION|FL|RANGE|ZERO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gomark"
#endif
#if OPT_ONLINEHELP
		,""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotobop) = {
	INIT_UNION(gotobop),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotobop"
#endif
#if OPT_ONLINEHELP
		,"move to the start of CNT'th paragraph"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoeop) = {
	INIT_UNION(gotoeop),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoeop"
#endif
#if OPT_ONLINEHELP
		,"move to the end of CNT'th paragraph"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_gotobob) = {
	INIT_UNION(gotobob),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotobob"
#endif
#if OPT_ONLINEHELP
		,"move to the top of the buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoeob) = {
	INIT_UNION(gotoeob),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoeob"
#endif
#if OPT_ONLINEHELP
		,"move to the end of the buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_gotobol) = {
	INIT_UNION(gotobol),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotobol"
#endif
#if OPT_ONLINEHELP
		,"move to the very beginning of the line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoeol) = {
	INIT_UNION(gotoeol),
	GOAL|MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoeol"
#endif
#if OPT_ONLINEHELP
		,"move to the very end of the CNT'th line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotobos) = {
	INIT_UNION(gotobos),
	ABSM|MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotobos"
#endif
#if OPT_ONLINEHELP
		,"move to the CNT'th line on the screen"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotomos) = {
	INIT_UNION(gotomos),
	ABSM|MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotomos"
#endif
#if OPT_ONLINEHELP
		,"move to the line in the middle of the screen"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoeos) = {
	INIT_UNION(gotoeos),
	ABSM|MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoeos"
#endif
#if OPT_ONLINEHELP
		,"move to the CNT'th line from the bottom of the screen"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotobosec) = {
	INIT_UNION(gotobosec),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotobosec"
#endif
#if OPT_ONLINEHELP
		,"move to the CNT'th previous start of a \"section\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoeosec) = {
	INIT_UNION(gotoeosec),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoeosec"
#endif
#if OPT_ONLINEHELP
		,"move forward to the CNT'th start of a \"section\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotobosent) = {
	INIT_UNION(gotobosent),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotobosent"
#endif
#if OPT_ONLINEHELP
		,"move to the CNT'th previous start of a \"sentence\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoeosent) = {
	INIT_UNION(gotoeosent),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoeosent"
#endif
#if OPT_ONLINEHELP
		,"move to the CNT'th start of a \"sentence\""
#endif
 };
#if OPT_TAGS
	DECL_EXTERN_CONST(CMDFUNC f_gototag) = {
	INIT_UNION(gototag),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gototag"
#endif
#if OPT_ONLINEHELP
		,"look up the given (or under-cursor) name as a \"tag\""
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_gotochr) = {
	INIT_UNION(gotochr),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotochr"
#endif
#if OPT_ONLINEHELP
		,"go to the CNT'th character.  unspecified CNT means end of buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotopct) = {
	INIT_UNION(gotopct),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotopct"
#endif
#if OPT_ONLINEHELP
		,"go to the CNT'th percent of the file.  unspecified CNT means end of buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_gotocol) = {
	INIT_UNION(gotocol),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotocol"
#endif
#if OPT_ONLINEHELP
		,"go to the CNT'th column on the line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gotoline) = {
	INIT_UNION(gotoline),
	ABSM|MOTION|FL|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gotoline"
#endif
#if OPT_ONLINEHELP
		,"go to the CNT'th line.  unspecified CNT means end of buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_golinenmmark) = {
	INIT_UNION(golinenmmark),
	MOTION|FL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"golinenmmark"
#endif
#if OPT_ONLINEHELP
		,"move to line containing the mark, at first non-white character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_goexactnmmark) = {
	INIT_UNION(goexactnmmark),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"goexactnmmark"
#endif
#if OPT_ONLINEHELP
		,"move to the given mark"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gorectnmmark) = {
	INIT_UNION(gorectnmmark),
	MOTION|VL_RECT
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gorectnmmark"
#endif
#if OPT_ONLINEHELP
		,"move to the mark, implying a rectangle if used with an operator"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_help) = {
	INIT_UNION(vl_help),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_help"
#endif
#if OPT_ONLINEHELP
		,"bring up a buffer containing lots of barely sorted information"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_histbuff) = {
	INIT_UNION(histbuff),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"histbuff"
#endif
#if OPT_ONLINEHELP
		,"visit the CNT'th previous buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_histbuff_to_current_window) = {
	INIT_UNION(histbuff_to_current_window),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"histbuff_to_current_window"
#endif
#if OPT_ONLINEHELP
		,"visit the CNT'th previous buffer and put it in the current window"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_insert) = {
	INIT_UNION(insert),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insert"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) text before the cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_insert_no_aindent) = {
	INIT_UNION(insert_no_aindent),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insert_no_aindent"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) text before the cursor, suppressing autoindent"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_insertbol) = {
	INIT_UNION(insertbol),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insertbol"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) text before the first non-white char on line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_insfile) = {
	INIT_UNION(insfile),
	REDO|UNDO|GLOBOK|FROM|ZERO|NAMEDF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insfile"
#endif
#if OPT_ONLINEHELP
		,"read the given file into the current buffer at the current line"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_insspace) = {
	INIT_UNION(insspace),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insspace"
#endif
#if OPT_ONLINEHELP
		,"insert CNT space character(s) at the cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_insstring) = {
	INIT_UNION(insstring),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insstring"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) the given string at the cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_insnumber) = {
	INIT_UNION(insnumber),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"insnumber"
#endif
#if OPT_ONLINEHELP
		,"insert (CNT copies of) the given character-number at the cursor"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_joinlines) = {
	INIT_UNION(joinlines),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"joinlines"
#endif
#if OPT_ONLINEHELP
		,"join CNT lines together with the current one"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_for_buffers) = {
	INIT_UNION(for_buffers),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"for_buffers"
#endif
#if OPT_ONLINEHELP
		,"for each buffer matched by the pattern, perform the command (CNT as per command)"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_killbuffer) = {
	INIT_UNION(killbuffer),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"killbuffer"
#endif
#if OPT_ONLINEHELP
		,"eliminate the given or (CNT times) under-cursor buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_showlength) = {
	INIT_UNION(showlength),
	DFLALL|FROM|TO|NOMOVE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showlength"
#endif
#if OPT_ONLINEHELP
		,"report number of lines in current buffer"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_lastnonwhite) = {
	INIT_UNION(lastnonwhite),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"lastnonwhite"
#endif
#if OPT_ONLINEHELP
		,"move to the last non-whitespace character on line"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_listbuffers) = {
	INIT_UNION(listbuffers),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"listbuffers"
#endif
#if OPT_ONLINEHELP
		,"show the current list of buffers.  give CNT to force showing all"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_set_args) = {
	INIT_UNION(vl_set_args),
	FILES
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_set_args"
#endif
#if OPT_ONLINEHELP
		,"reset the current list of visible buffers."
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_set_args2) = {
	INIT_UNION(vl_set_args2),
	FILES
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_set_args2"
#endif
#if OPT_ONLINEHELP
		,"reset the current list of visible buffers, even if some are modified."
#endif
 };
#if OPT_HISTORY
	DECL_EXTERN_CONST(CMDFUNC f_showhistory) = {
	INIT_UNION(showhistory),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showhistory"
#endif
#if OPT_ONLINEHELP
		,"show the command history"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_lineputafter) = {
	INIT_UNION(lineputafter),
	REDO|UNDO|GLOBOK|FROM|ZERO|OPTREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"lineputafter"
#endif
#if OPT_ONLINEHELP
		,"insert CNT times from (un)named register, as whole lines, after current line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_lineputbefore) = {
	INIT_UNION(lineputbefore),
	REDO|UNDO|GLOBOK|FROM|OPTREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"lineputbefore"
#endif
#if OPT_ONLINEHELP
		,"insert CNT times from (un)named register, as whole lines, before current line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_rectputafter) = {
	INIT_UNION(rectputafter),
	REDO|UNDO|GLOBOK|FROM|ZERO|OPTREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"rectputafter"
#endif
#if OPT_ONLINEHELP
		,"insert CNT times from (un)named register, as a rectangle, after cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_rectputbefore) = {
	INIT_UNION(rectputbefore),
	REDO|UNDO|GLOBOK|FROM|OPTREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"rectputbefore"
#endif
#if OPT_ONLINEHELP
		,"insert CNT times from (un)named register, as a rectangle, in front of cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_lineundo) = {
	INIT_UNION(lineundo),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"lineundo"
#endif
#if OPT_ONLINEHELP
		,"undo all changes made to most recently altered line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_loadkreg) = {
	INIT_UNION(loadkreg),
	USEREG|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"loadkreg"
#endif
#if OPT_ONLINEHELP
		,"load the given string into the currently named register.  give CNT for full-lines."
#endif
 };
#if OPT_PLUGIN
	DECL_EXTERN_CONST(CMDFUNC f_loadplugin) = {
	INIT_UNION(loadplugin),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"loadplugin"
#endif
#if OPT_ONLINEHELP
		,"try to load a plug-in from a shared-library file"
#endif
 };
#endif
#if OPT_SHOW_REGS
	DECL_EXTERN_CONST(CMDFUNC f_showkreg) = {
	INIT_UNION(showkreg),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showkreg"
#endif
#if OPT_ONLINEHELP
		,"show the contents of all of the named and unnamed registers"
#endif
 };
#endif
#if OPT_SHOW_MAPS
	DECL_EXTERN_CONST(CMDFUNC f_sysmap) = {
	INIT_UNION(sysmap),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"sysmap"
#endif
#if OPT_ONLINEHELP
		,"list the system function-key maps"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_map) = {
	INIT_UNION(map),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"map"
#endif
#if OPT_ONLINEHELP
		,"create a new map, or show list of the current command-mode maps"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_map_bang) = {
	INIT_UNION(map_bang),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"map_bang"
#endif
#if OPT_ONLINEHELP
		,"create a new map, or show list of the current insert-mode maps"
#endif
 };
#if OPT_MENUS
	DECL_EXTERN_CONST(CMDFUNC f_gui_hide_menus) = {
	INIT_UNION(gui_hide_menus),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gui_hide_menus"
#endif
#if OPT_ONLINEHELP
		,"hide the menu-bar"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gui_remove_menus) = {
	INIT_UNION(gui_remove_menus),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gui_remove_menus"
#endif
#if OPT_ONLINEHELP
		,"remove the menus"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_gui_show_menus) = {
	INIT_UNION(gui_show_menus),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"gui_show_menus"
#endif
#if OPT_ONLINEHELP
		,"display the menus, if hidden"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vlmenu_load) = {
	INIT_UNION(vlmenu_load),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vlmenu_load"
#endif
#if OPT_ONLINEHELP
		,"load menus from external file"
#endif
 };
#endif
#if OPT_TAGS
	DECL_EXTERN_CONST(CMDFUNC f_nexttag) = {
	INIT_UNION(nexttag),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"nexttag"
#endif
#if OPT_ONLINEHELP
		,"search the tags file(s) for another location for the last tag"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_newprocessgroup) = {
	INIT_UNION(newprocessgroup),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"newprocessgroup"
#endif
#if OPT_ONLINEHELP
		,"put editor into its own process group (X11 version only)"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_noremap) = {
	INIT_UNION(noremap),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"noremap"
#endif
#if OPT_ONLINEHELP
		,"create a new unremappable command-mode map"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_noremap_bang) = {
	INIT_UNION(noremap_bang),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"noremap_bang"
#endif
#if OPT_ONLINEHELP
		,"create a new unremappable insert-mode map"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_cntl_a_func) = {
	INIT_UNION(cntl_a_func),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cntl_a_func"
#endif
#if OPT_ONLINEHELP
		,"the \"Control-A\" prefix, used when typing extended commands"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_mvdnnxtwind) = {
	INIT_UNION(mvdnnxtwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mvdnnxtwind"
#endif
#if OPT_ONLINEHELP
		,"move next window down (or buffer up) by CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_mvupnxtwind) = {
	INIT_UNION(mvupnxtwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mvupnxtwind"
#endif
#if OPT_ONLINEHELP
		,"move next window up (or buffer down) by CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_mvdnwind) = {
	INIT_UNION(mvdnwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mvdnwind"
#endif
#if OPT_ONLINEHELP
		,"move window down (or buffer up) by CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_mvupwind) = {
	INIT_UNION(mvupwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mvupwind"
#endif
#if OPT_ONLINEHELP
		,"move window up (or buffer down) by CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_mvrightwind) = {
	INIT_UNION(mvrightwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mvrightwind"
#endif
#if OPT_ONLINEHELP
		,"scroll window to right by CNT columns, half screen if CNT unspecified"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_mvleftwind) = {
	INIT_UNION(mvleftwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mvleftwind"
#endif
#if OPT_ONLINEHELP
		,"scroll window to left by CNT columns, half screen if CNT unspecified"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_nextbuffer) = {
	INIT_UNION(nextbuffer),
	BANG|NAMEDFS
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"nextbuffer"
#endif
#if OPT_ONLINEHELP
		,"switch to next buffer (or the least-recently-visited, if \"autobuffer\" on"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_namebuffer) = {
	INIT_UNION(namebuffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"namebuffer"
#endif
#if OPT_ONLINEHELP
		,"give the current buffer a new name"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_name_a_buffer) = {
	INIT_UNION(name_a_buffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"name_a_buffer"
#endif
#if OPT_ONLINEHELP
		,"give the specified buffer a new name"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_newline) = {
	INIT_UNION(newline),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"newline"
#endif
#if OPT_ONLINEHELP
		,"insert a newline at the cursor, CNT times"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_newlength) = {
	INIT_UNION(newlength),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"newlength"
#endif
#if OPT_ONLINEHELP
		,"tell the editor the screen has CNT rows"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_newwidth) = {
	INIT_UNION(newwidth),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"newwidth"
#endif
#if OPT_ONLINEHELP
		,"tell the editor the screen has CNT columns"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_nextwind) = {
	INIT_UNION(nextwind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"nextwind"
#endif
#if OPT_ONLINEHELP
		,"move to the next window.  repeat with CNT"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_nullproc) = {
	INIT_UNION(nullproc),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"nullproc"
#endif
#if OPT_ONLINEHELP
		,"do nothing"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_namedcmd) = {
	INIT_UNION(namedcmd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"namedcmd"
#endif
#if OPT_ONLINEHELP
		,"execute the given function, by name, applying CNT as its repeat-count"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_openup) = {
	INIT_UNION(openup),
	REDO|UNDO|(FROM)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"openup"
#endif
#if OPT_ONLINEHELP
		,"insert text in CNT fresh blank line(s), before current line"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_openup_i) = {
	INIT_UNION(openup_i),
	REDO|UNDO|(FROM)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"openup_i"
#endif
#if OPT_ONLINEHELP
		,"insert text in CNT fresh blank line(s), before current line, toggle autoindent"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_openup_no_aindent) = {
	INIT_UNION(openup_no_aindent),
	REDO|UNDO|FROM|ZERO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"openup_no_aindent"
#endif
#if OPT_ONLINEHELP
		,"insert text in CNT fresh blank line(s), before current, no autoindent"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opendown) = {
	INIT_UNION(opendown),
	REDO|UNDO|FROM|ZERO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opendown"
#endif
#if OPT_ONLINEHELP
		,"insert text in CNT fresh blank line(s), after current line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opendown_no_aindent) = {
	INIT_UNION(opendown_no_aindent),
	REDO|UNDO|FROM|ZERO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opendown_no_aindent"
#endif
#if OPT_ONLINEHELP
		,"insert text in CNT fresh blank line(s), after current, no autoindent"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operopenrect) = {
	INIT_UNION(operopenrect),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operopenrect"
#endif
#if OPT_ONLINEHELP
		,"open blank rectangular area specified by given motion"
#endif
 };
#if OPT_SELECTIONS
	DECL_EXTERN_CONST(CMDFUNC f_operattrbold) = {
	INIT_UNION(operattrbold),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrbold"
#endif
#if OPT_ONLINEHELP
		,"display text as bold in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operattrcaseq) = {
	INIT_UNION(operattrcaseq),
	REDO|UNDO|OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrcaseq"
#endif
#if OPT_ONLINEHELP
		,"display text as given by ^A sequences in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operattrencode) = {
	INIT_UNION(operattrencode),
	REDO|UNDO|OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrencode"
#endif
#if OPT_ONLINEHELP
		,"encode attributes in the region as ^A sequences"
#endif
 };
#endif
#if OPT_SELECTIONS&&OPT_FILTER
	DECL_EXTERN_CONST(CMDFUNC f_operattrdirect) = {
	INIT_UNION(operattrdirect),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrdirect"
#endif
#if OPT_ONLINEHELP
		,"directly attribute region using internal filter"
#endif
 };
#endif
#if OPT_SELECTIONS&&OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_operattrfilter) = {
	INIT_UNION(operattrfilter),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrfilter"
#endif
#if OPT_ONLINEHELP
		,"read/apply ^A sequence attributes by filtering the region"
#endif
 };
#endif
#if OPT_HYPERTEXT
	DECL_EXTERN_CONST(CMDFUNC f_operattrhc) = {
	INIT_UNION(operattrhc),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrhc"
#endif
#if OPT_ONLINEHELP
		,"attach hypertext command to region"
#endif
 };
#endif
#if OPT_SELECTIONS
	DECL_EXTERN_CONST(CMDFUNC f_operattrital) = {
	INIT_UNION(operattrital),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrital"
#endif
#if OPT_ONLINEHELP
		,"display text in italics in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operattrno) = {
	INIT_UNION(operattrno),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrno"
#endif
#if OPT_ONLINEHELP
		,"display text normally in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operattrrev) = {
	INIT_UNION(operattrrev),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrrev"
#endif
#if OPT_ONLINEHELP
		,"display text reversed in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operattrul) = {
	INIT_UNION(operattrul),
	OPER|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operattrul"
#endif
#if OPT_ONLINEHELP
		,"display text underlined in the region"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_operchg) = {
	INIT_UNION(operchg),
	OPER|REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operchg"
#endif
#if OPT_ONLINEHELP
		,"insert text, replacing that in the region"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_operchg_i) = {
	INIT_UNION(operchg_i),
	OPER|REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operchg_i"
#endif
#if OPT_ONLINEHELP
		,"insert text, replacing that in the region, toggles autoindent"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_operdetab) = {
	INIT_UNION(operdetab),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operdetab"
#endif
#if OPT_ONLINEHELP
		,"convert tabs to spaces in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_oper_l_detab) = {
	INIT_UNION(oper_l_detab),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"oper_l_detab"
#endif
#if OPT_ONLINEHELP
		,"convert leading tabs to spaces in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operentab) = {
	INIT_UNION(operentab),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operentab"
#endif
#if OPT_ONLINEHELP
		,"convert spaces to tabs where possible in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_oper_l_entab) = {
	INIT_UNION(oper_l_entab),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"oper_l_entab"
#endif
#if OPT_ONLINEHELP
		,"convert leading spaces to tabs where possible in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opermove) = {
	INIT_UNION(opermove),
	OPER|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opermove"
#endif
#if OPT_ONLINEHELP
		,"move text in the region to the given line"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operlinechg) = {
	INIT_UNION(operlinechg),
	OPER|REDO|UNDO|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operlinechg"
#endif
#if OPT_ONLINEHELP
		,"insert text, replacing that on the lines covered by the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operdel) = {
	INIT_UNION(operdel),
	OPER|REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operdel"
#endif
#if OPT_ONLINEHELP
		,"delete text in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operjoin) = {
	INIT_UNION(operjoin),
	OPER|REDO|UNDO|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operjoin"
#endif
#if OPT_ONLINEHELP
		,"join together lines in the region, adjusting whitespace at join"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operjoin_x) = {
	INIT_UNION(operjoin_x),
	OPER|REDO|UNDO|GLOBOK|RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operjoin_x"
#endif
#if OPT_ONLINEHELP
		,"join together lines in the region without whitespace adjustment"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operlinedel) = {
	INIT_UNION(operlinedel),
	OPER|REDO|UNDO|GLOBOK|RANGE|OPTREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operlinedel"
#endif
#if OPT_ONLINEHELP
		,"delete lines covered by the region"
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_operfilter) = {
	INIT_UNION(operfilter),
	OPER|REDO|UNDO|EXRCOK|RANGE|NAMEDFS|DFLNONE|VI_NL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operfilter"
#endif
#if OPT_ONLINEHELP
		,"pipe the text in the region through an external filter command"
#endif
 };
#endif
#if OPT_FORMAT
	DECL_EXTERN_CONST(CMDFUNC f_operformat) = {
	INIT_UNION(operformat),
	OPER|REDO|UNDO|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operformat"
#endif
#if OPT_ONLINEHELP
		,"format (rejustify) the text in the region"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_operflip) = {
	INIT_UNION(operflip),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operflip"
#endif
#if OPT_ONLINEHELP
		,"exchange upper and lowercase on characters in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operglobals) = {
	INIT_UNION(operglobals),
	BANG|EXTRA|DFLALL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operglobals"
#endif
#if OPT_ONLINEHELP
		,"perform command on all lines containing the given pattern"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opervglobals) = {
	INIT_UNION(opervglobals),
	BANG|EXTRA|DFLALL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opervglobals"
#endif
#if OPT_ONLINEHELP
		,"perform command on all lines not containing the given pattern"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operlower) = {
	INIT_UNION(operlower),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operlower"
#endif
#if OPT_ONLINEHELP
		,"convert to lowercase all characters in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operlist) = {
	INIT_UNION(operlist),
	OPER|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operlist"
#endif
#if OPT_ONLINEHELP
		,"show lines, making tabs and newlines visible"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opernumber) = {
	INIT_UNION(opernumber),
	OPER|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opernumber"
#endif
#if OPT_ONLINEHELP
		,"show lines with their line numbers"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operprint) = {
	INIT_UNION(operprint),
	OPER|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operprint"
#endif
#if OPT_ONLINEHELP
		,"show lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operpprint) = {
	INIT_UNION(operpprint),
	OPER|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operpprint"
#endif
#if OPT_ONLINEHELP
		,"show lines with line numbers"
#endif
 };
#if OPT_SELECTIONS
	DECL_EXTERN_CONST(CMDFUNC f_operselect) = {
	INIT_UNION(operselect),
	OPER|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operselect"
#endif
#if OPT_ONLINEHELP
		,"select (and yank) the text in the region"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_operupper) = {
	INIT_UNION(operupper),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operupper"
#endif
#if OPT_ONLINEHELP
		,"convert to uppercase all characters in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operlshift) = {
	INIT_UNION(operlshift),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operlshift"
#endif
#if OPT_ONLINEHELP
		,"shift lines in the region left by one \"shiftwidth\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operrshift) = {
	INIT_UNION(operrshift),
	OPER|REDO|UNDO|GLOBOK|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operrshift"
#endif
#if OPT_ONLINEHELP
		,"shift lines in the region right by one \"shiftwidth\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opersubst) = {
	INIT_UNION(opersubst),
	OPER|REDO|UNDO|GLOBOK|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opersubst"
#endif
#if OPT_ONLINEHELP
		,"perform a text substitution over the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opersubstall) = {
	INIT_UNION(opersubstall),
	OPER|REDO|UNDO|GLOBOK|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opersubstall"
#endif
#if OPT_ONLINEHELP
		,"perform an all-occurrence text substitution over the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opertrim) = {
	INIT_UNION(opertrim),
	REDO|UNDO|GLOBOK|UNDO|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opertrim"
#endif
#if OPT_ONLINEHELP
		,"trim trailing whitespace from lines in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operblank) = {
	INIT_UNION(operblank),
	REDO|UNDO|GLOBOK|UNDO|(RANGE)
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operblank"
#endif
#if OPT_ONLINEHELP
		,"replace the region with whitespace"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operyank) = {
	INIT_UNION(operyank),
	OPER
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operyank"
#endif
#if OPT_ONLINEHELP
		,"get the region into the given named or unnamed register"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operlineyank) = {
	INIT_UNION(operlineyank),
	OPER|RANGE|OPTREG|NOMOVE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operlineyank"
#endif
#if OPT_ONLINEHELP
		,"get lines covered by region into given named or unnamed register"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opersubstagain) = {
	INIT_UNION(opersubstagain),
	OPER|REDO|UNDO|GLOBOK|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opersubstagain"
#endif
#if OPT_ONLINEHELP
		,"redo the previous text substitution over the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opertransf) = {
	INIT_UNION(opertransf),
	OPER|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opertransf"
#endif
#if OPT_ONLINEHELP
		,"copy text in the region"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_operwrite) = {
	INIT_UNION(operwrite),
	OPER|RANGE|BANG|FILE1|DFLALL|NOMOVE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"operwrite"
#endif
#if OPT_ONLINEHELP
		,"write from region to the given file.  whole buffer by default"
#endif
 };
#if OPT_SELECTIONS
	DECL_EXTERN_CONST(CMDFUNC f_oper_wrenc) = {
	INIT_UNION(oper_wrenc),
	OPER|RANGE|BANG|FILE1|DFLALL|NOMOVE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"oper_wrenc"
#endif
#if OPT_ONLINEHELP
		,"write attributed text from region to file.  whole buffer by default"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_overwritechars) = {
	INIT_UNION(overwritechars),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"overwritechars"
#endif
#if OPT_ONLINEHELP
		,"replace text while inserting, character by character"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_overwstring) = {
	INIT_UNION(overwstring),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"overwstring"
#endif
#if OPT_ONLINEHELP
		,"replace text at the cursor by the given string"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_overwnumber) = {
	INIT_UNION(overwnumber),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"overwnumber"
#endif
#if OPT_ONLINEHELP
		,"replace text at the cursor by the given character-number"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_onlywind) = {
	INIT_UNION(onlywind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"onlywind"
#endif
#if OPT_ONLINEHELP
		,"eliminate all windows except the current"
#endif
 };
#if OPT_PERL
	DECL_EXTERN_CONST(CMDFUNC f_perl) = {
	INIT_UNION(perl),
	OPER|REDO|UNDO|GLOBOK|RANGE|DFLNONE|VIEWOK
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"perl"
#endif
#if OPT_ONLINEHELP
		,"run a perl command"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_perldo) = {
	INIT_UNION(perldo),
	OPER|REDO|UNDO|GLOBOK|RANGE|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"perldo"
#endif
#if OPT_ONLINEHELP
		,"run a perl command on each line in a range"
#endif
 };
#endif
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_popd) = {
	INIT_UNION(popd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"popd"
#endif
#if OPT_ONLINEHELP
		,"implements bash's popd semantics (i.e., cd `pop dirstack`)"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_poswind) = {
	INIT_UNION(poswind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"poswind"
#endif
#if OPT_ONLINEHELP
		,"reframe with cursor at center (.,M,m), top (CR,H,t), or bottom (-,L,b)"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_prevbuffer) = {
	INIT_UNION(prevbuffer),
	BANG|NAMEDFS
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"prevbuffer"
#endif
#if OPT_ONLINEHELP
		,"switch to previous buffer (or the most-recently-visited, if \"autobuffer\" on"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_prevwind) = {
	INIT_UNION(prevwind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"prevwind"
#endif
#if OPT_ONLINEHELP
		,"move to the previous window.  repeat with CNT"
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_pushd) = {
	INIT_UNION(pushd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"pushd"
#endif
#if OPT_ONLINEHELP
		,"implements bash's pushd semantics (i.e., cd \"dir\", push \"dir\" on dirstack)"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_capturecmd) = {
	INIT_UNION(capturecmd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"capturecmd"
#endif
#if OPT_ONLINEHELP
		,"run a command, capturing its output in the [Output] buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_putafter) = {
	INIT_UNION(putafter),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"putafter"
#endif
#if OPT_ONLINEHELP
		,"insert CNT copies of (un)named register, after cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_putbefore) = {
	INIT_UNION(putbefore),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"putbefore"
#endif
#if OPT_ONLINEHELP
		,"insert CNT copies of (un)named register, before cursor"
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_pwd) = {
	INIT_UNION(pwd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"pwd"
#endif
#if OPT_ONLINEHELP
		,"show current directory name"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_quit) = {
	INIT_UNION(quit),
	BANG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"quit"
#endif
#if OPT_ONLINEHELP
		,"leave the editor, if there are no modified buffers"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_quithard) = {
	INIT_UNION(quithard),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"quithard"
#endif
#if OPT_ONLINEHELP
		,"leave the editor, regardless of modified buffers"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_quickexit) = {
	INIT_UNION(quickexit),
	BANG|VI_NL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"quickexit"
#endif
#if OPT_ONLINEHELP
		,"leave the editor, writing modified buffers as needed"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_quote_next) = {
	INIT_UNION(quote_next),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"quote_next"
#endif
#if OPT_ONLINEHELP
		,"insert the next character literally, CNT times"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vile_refresh) = {
	INIT_UNION(vile_refresh),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vile_refresh"
#endif
#if OPT_ONLINEHELP
		,"redraw the screen"
#endif
 };
#if OPT_MAJORMODE
	DECL_EXTERN_CONST(CMDFUNC f_remove_mode) = {
	INIT_UNION(remove_mode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"remove_mode"
#endif
#if OPT_ONLINEHELP
		,"delete the definition of a major mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_remove_submode) = {
	INIT_UNION(remove_submode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"remove_submode"
#endif
#if OPT_ONLINEHELP
		,"delete the special definition of a submode from a major mode"
#endif
 };
#endif
#if OPT_COLOR_SCHEMES
	DECL_EXTERN_CONST(CMDFUNC f_remove_scheme) = {
	INIT_UNION(remove_scheme),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"remove_scheme"
#endif
#if OPT_ONLINEHELP
		,"delete the given color scheme"
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_reposition) = {
	INIT_UNION(reposition),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"reposition"
#endif
#if OPT_ONLINEHELP
		,"redraw, cursor at center, or CNT'th line, or CNT'th from end if neg"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_rep_csrch) = {
	INIT_UNION(rep_csrch),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"rep_csrch"
#endif
#if OPT_ONLINEHELP
		,"repeat the last forward character scan"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_replacechar) = {
	INIT_UNION(replacechar),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"replacechar"
#endif
#if OPT_ONLINEHELP
		,"replace CNT characters at the cursor with the given character"
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_respawn) = {
	INIT_UNION(respawn),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"respawn"
#endif
#if OPT_ONLINEHELP
		,"rerun the previously entered shell command"
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_resize) = {
	INIT_UNION(resize),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"resize"
#endif
#if OPT_ONLINEHELP
		,"change the current window to CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_restwnd) = {
	INIT_UNION(restwnd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"restwnd"
#endif
#if OPT_ONLINEHELP
		,"return to window saved with \"save-window\""
#endif
 };
#endif
#if OPT_MAJORMODE
	DECL_EXTERN_CONST(CMDFUNC f_reset_majormode) = {
	INIT_UNION(reset_majormode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"reset_majormode"
#endif
#if OPT_ONLINEHELP
		,"recompute $majormode for the current buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_rev_csrch) = {
	INIT_UNION(rev_csrch),
	MOTION|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"rev_csrch"
#endif
#if OPT_ONLINEHELP
		,"repeat the last backward character scan"
#endif
 };
#if OPT_ISRCH
	DECL_EXTERN_CONST(CMDFUNC f_risearch) = {
	INIT_UNION(risearch),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"risearch"
#endif
#if OPT_ONLINEHELP
		,"search backwards for a pattern entered character by character"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_revsearch) = {
	INIT_UNION(revsearch),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"revsearch"
#endif
#if OPT_ONLINEHELP
		,"search for previous pattern in opposite direction from before"
#endif
 };
#if OPT_SELECTIONS&&OPT_SEL_YANK
	DECL_EXTERN_CONST(CMDFUNC f_sel_all) = {
	INIT_UNION(sel_all),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"sel_all"
#endif
#if OPT_ONLINEHELP
		,"select all text in current buffer and yank to unnamed buffer"
#endif
 };
#endif
#if OPT_SELECTIONS
	DECL_EXTERN_CONST(CMDFUNC f_sel_clear) = {
	INIT_UNION(sel_clear),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"sel_clear"
#endif
#if OPT_ONLINEHELP
		,"clear text selection's highlight attributes"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_sel_motion) = {
	INIT_UNION(sel_motion),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"sel_motion"
#endif
#if OPT_ONLINEHELP
		,"move to selection.  if used with operator, region is the selection"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_scrforwsearch) = {
	INIT_UNION(scrforwsearch),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"scrforwsearch"
#endif
#if OPT_ONLINEHELP
		,"search forward for $identifier pattern under cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_scrbacksearch) = {
	INIT_UNION(scrbacksearch),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"scrbacksearch"
#endif
#if OPT_ONLINEHELP
		,"search backwards for $identifier pattern under cursor"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_scrsearchpat) = {
	INIT_UNION(scrsearchpat),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"scrsearchpat"
#endif
#if OPT_ONLINEHELP
		,"set search pattern to $identifier pattern under cursor"
#endif
 };
#if OPT_SHOW_CTYPE
	DECL_EXTERN_CONST(CMDFUNC f_set_charclass) = {
	INIT_UNION(set_charclass),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_charclass"
#endif
#if OPT_ONLINEHELP
		,"add characters to class, given keyword and regular expression"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unset_charclass) = {
	INIT_UNION(unset_charclass),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unset_charclass"
#endif
#if OPT_ONLINEHELP
		,"remove characters from class, given keyword and regular expression"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_reset_charclasses) = {
	INIT_UNION(reset_charclasses),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"reset_charclasses"
#endif
#if OPT_ONLINEHELP
		,"remove user-defined character class changes"
#endif
 };
#endif
#if OPT_DOSFILES
	DECL_EXTERN_CONST(CMDFUNC f_set_rs_crlf) = {
	INIT_UNION(set_rs_crlf),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_rs_crlf"
#endif
#if OPT_ONLINEHELP
		,"force a \"dos\"-style buffer: trim CR characters, and set \"dos-mode\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_set_rs_lf) = {
	INIT_UNION(set_rs_lf),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_rs_lf"
#endif
#if OPT_ONLINEHELP
		,"force a \"unix\"-style buffer: trim CR characters, and unset \"dos-mode\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_set_rs_cr) = {
	INIT_UNION(set_rs_cr),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_rs_cr"
#endif
#if OPT_ONLINEHELP
		,"force a \"mac\"-style buffer: convert LF to CR, unset \"dos-mode\""
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_settab) = {
	INIT_UNION(settab),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"settab"
#endif
#if OPT_ONLINEHELP
		,"set the tabstop setting to CNT.  same as \"set tabstop=NN\""
#endif
 };
#if OPT_REBIND&&OPT_TERMCHRS
	DECL_EXTERN_CONST(CMDFUNC f_set_termchrs) = {
	INIT_UNION(set_termchrs),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_termchrs"
#endif
#if OPT_ONLINEHELP
		,"change the value of a terminal special character"
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_set_window) = {
	INIT_UNION(set_window),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_window"
#endif
#if OPT_ONLINEHELP
		,"set the current window to a specific buffer"
#endif
 };
#endif
#if OPT_REBIND&&OPT_TERMCHRS
	DECL_EXTERN_CONST(CMDFUNC f_show_termchrs) = {
	INIT_UNION(show_termchrs),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"show_termchrs"
#endif
#if OPT_ONLINEHELP
		,"show the values of the terminal special characters"
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_show_undostk) = {
	INIT_UNION(show_undostk),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"show_undostk"
#endif
#if OPT_ONLINEHELP
		,"show the contents of the undo-stack"
#endif
 };
#endif
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_spawncli) = {
	INIT_UNION(spawncli),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"spawncli"
#endif
#if OPT_ONLINEHELP
		,"start a sub-shell in which to run commands"
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_savewnd) = {
	INIT_UNION(savewnd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"savewnd"
#endif
#if OPT_ONLINEHELP
		,"mark a window for later return with \"restore-window\""
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_scrnextup) = {
	INIT_UNION(scrnextup),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"scrnextup"
#endif
#if OPT_ONLINEHELP
		,"move next window up by CNT half screens"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_scrnextdw) = {
	INIT_UNION(scrnextdw),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"scrnextdw"
#endif
#if OPT_ONLINEHELP
		,"move next window down by CNT half screens"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_setfillcol) = {
	INIT_UNION(setfillcol),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"setfillcol"
#endif
#if OPT_ONLINEHELP
		,"set the fillcol setting to CNT.  same as \"set fillcol=NN\""
#endif
 };
#if OPT_SHELL&&defined(HAVE_PUTENV)
	DECL_EXTERN_CONST(CMDFUNC f_set_envvar) = {
	INIT_UNION(set_envvar),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"set_envvar"
#endif
#if OPT_ONLINEHELP
		,"set and export a process environment variable"
#endif
 };
#endif
#if OPT_SELECTIONS
	DECL_EXTERN_CONST(CMDFUNC f_multimotion) = {
	INIT_UNION(multimotion),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"multimotion"
#endif
#if OPT_ONLINEHELP
		,"start (and end) a selection using multiple motions, CNT is type (1) "
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_multimotionfullline) = {
	INIT_UNION(multimotionfullline),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"multimotionfullline"
#endif
#if OPT_ONLINEHELP
		,"start (and end) a full-line selection using multiple motions (2) "
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_multimotionrectangle) = {
	INIT_UNION(multimotionrectangle),
	MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"multimotionrectangle"
#endif
#if OPT_ONLINEHELP
		,"start (and end) a rectangular selection using multiple motions (3) "
#endif
 };
#endif
#if OPT_ENCRYPT
	DECL_EXTERN_CONST(CMDFUNC f_vl_setkey) = {
	INIT_UNION(vl_setkey),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_setkey"
#endif
#if OPT_ONLINEHELP
		,"set the encryption key on the current buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_setlocmode) = {
	INIT_UNION(setlocmode),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"setlocmode"
#endif
#if OPT_ONLINEHELP
		,"change the current buffer's local value of a mode setting"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_setglobmode) = {
	INIT_UNION(setglobmode),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"setglobmode"
#endif
#if OPT_ONLINEHELP
		,"change the global value of a mode setting"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_setnmmark) = {
	INIT_UNION(setnmmark),
	FROM|EXTRA|NOMOVE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"setnmmark"
#endif
#if OPT_ONLINEHELP
		,"set the given named mark to the current cursor location"
#endif
 };
#if OPT_EVAL
	DECL_EXTERN_CONST(CMDFUNC f_setvar) = {
	INIT_UNION(setvar),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"setvar"
#endif
#if OPT_ONLINEHELP
		,"set the given vile variable to a value"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unsetvar) = {
	INIT_UNION(unsetvar),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unsetvar"
#endif
#if OPT_ONLINEHELP
		,"reset the given vile variable to an empty string or default-value"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_showcpos) = {
	INIT_UNION(showcpos),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showcpos"
#endif
#if OPT_ONLINEHELP
		,"report information about current buffer and character"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_listmodes) = {
	INIT_UNION(listmodes),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"listmodes"
#endif
#if OPT_ONLINEHELP
		,"report values of all mode settings"
#endif
 };
#if OPT_MAJORMODE
	DECL_EXTERN_CONST(CMDFUNC f_list_majormodes) = {
	INIT_UNION(list_majormodes),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"list_majormodes"
#endif
#if OPT_ONLINEHELP
		,"report values of all majormode settings (use CNT for verbose listing)"
#endif
 };
#endif
#if OPT_SHOW_EVAL
	DECL_EXTERN_CONST(CMDFUNC f_listvars) = {
	INIT_UNION(listvars),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"listvars"
#endif
#if OPT_ONLINEHELP
		,"report values of all variables, built-in and user"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_showversion) = {
	INIT_UNION(showversion),
	EXRCOK
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showversion"
#endif
#if OPT_ONLINEHELP
		,"report version information for the editor"
#endif
 };
#if OPT_SHOW_MARKS
	DECL_EXTERN_CONST(CMDFUNC f_showmarks) = {
	INIT_UNION(showmarks),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showmarks"
#endif
#if OPT_ONLINEHELP
		,"show named marks for the current buffer"
#endif
 };
#endif
#if SYS_MSDOS&&(CC_TURBO||CC_WATCOM||CC_DJGPP)
	DECL_EXTERN_CONST(CMDFUNC f_showmemory) = {
	INIT_UNION(showmemory),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showmemory"
#endif
#if OPT_ONLINEHELP
		,"report on available memory"
#endif
 };
#endif
#if OPT_SHOW_TAGS
	DECL_EXTERN_CONST(CMDFUNC f_showtagstack) = {
	INIT_UNION(showtagstack),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"showtagstack"
#endif
#if OPT_ONLINEHELP
		,"show the stack of successive tag references"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_shrinkwind) = {
	INIT_UNION(shrinkwind),
	GOAL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"shrinkwind"
#endif
#if OPT_ONLINEHELP
		,"decrease the size of the current window by CNT lines"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_source) = {
	INIT_UNION(vl_source),
	EXRCOK|NAMEDF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_source"
#endif
#if OPT_ONLINEHELP
		,"source a file of ex commands"
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_vl_spawn) = {
	INIT_UNION(vl_spawn),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_spawn"
#endif
#if OPT_ONLINEHELP
		,"run a shell command"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_poundc_func) = {
	INIT_UNION(poundc_func),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"poundc_func"
#endif
#if OPT_ONLINEHELP
		,"prefix used to represent commands normally bound to function keys"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_splitwind) = {
	INIT_UNION(splitwind),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"splitwind"
#endif
#if OPT_ONLINEHELP
		,"split the window in half; CNT of 1 or 2 chooses which becomes current"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_store_macro) = {
	INIT_UNION(store_macro),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"store_macro"
#endif
#if OPT_ONLINEHELP
		,"store script text into CNT'th macro, up to line starting with ~endm"
#endif
 };
#if OPT_PROCEDURES
	DECL_EXTERN_CONST(CMDFUNC f_store_proc) = {
	INIT_UNION(store_proc),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"store_proc"
#endif
#if OPT_ONLINEHELP
		,"store script text into given named stored-procedure; give CNT for store-macro CNT"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_store_op) = {
	INIT_UNION(store_op),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"store_op"
#endif
#if OPT_ONLINEHELP
		,"store script text into given named user-operator"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_subst_again) = {
	INIT_UNION(subst_again),
	REDO|UNDO|GLOBOK
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"subst_again"
#endif
#if OPT_ONLINEHELP
		,"redo the previous text substitution"
#endif
 };
#if SYS_WINNT&&defined(VILE_OLE)
	DECL_EXTERN_CONST(CMDFUNC f_syncfile) = {
	INIT_UNION(syncfile),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"syncfile"
#endif
#if OPT_ONLINEHELP
		,"synchronize the current buffer's file in DevStudio's editor"
#endif
 };
#endif
#if SYS_WINNT
	DECL_EXTERN_CONST(CMDFUNC f_swapcbrdkeys) = {
	INIT_UNION(swapcbrdkeys),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"swapcbrdkeys"
#endif
#if OPT_ONLINEHELP
		,"swap clipboard insert key mappings"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_togglelistbuffers) = {
	INIT_UNION(togglelistbuffers),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"togglelistbuffers"
#endif
#if OPT_ONLINEHELP
		,"show or hide the buffer list. give CNT to force showing all"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_twiddle) = {
	INIT_UNION(twiddle),
	REDO|UNDO|MINIBUF
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"twiddle"
#endif
#if OPT_ONLINEHELP
		,"exchange the two characters under and to the left of the cursor"
#endif
 };
#endif
#if OPT_REBIND
	DECL_EXTERN_CONST(CMDFUNC f_unbindkey) = {
	INIT_UNION(unbindkey),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unbindkey"
#endif
#if OPT_ONLINEHELP
		,"break the binding between a keystroke and a function"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unbind_i_key) = {
	INIT_UNION(unbind_i_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unbind_i_key"
#endif
#if OPT_ONLINEHELP
		,"break the binding between a keystroke and a function in insert-mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unbind_c_key) = {
	INIT_UNION(unbind_c_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unbind_c_key"
#endif
#if OPT_ONLINEHELP
		,"break the binding between a keystroke and a function in command-mode"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unbind_s_key) = {
	INIT_UNION(unbind_s_key),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unbind_s_key"
#endif
#if OPT_ONLINEHELP
		,"break the binding between a keystroke and a function in selection-mode"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_undo) = {
	INIT_UNION(undo),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"undo"
#endif
#if OPT_ONLINEHELP
		,"undo the last change made to a buffer;  repeat to reapply the change"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_inf_undo) = {
	INIT_UNION(inf_undo),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"inf_undo"
#endif
#if OPT_ONLINEHELP
		,"undo/redo more changes, continuing in \"direction\" of last undo/redo"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_backundo) = {
	INIT_UNION(backundo),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"backundo"
#endif
#if OPT_ONLINEHELP
		,"undo changes made to a buffer;  repeat to undo previous changes"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_forwredo) = {
	INIT_UNION(forwredo),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"forwredo"
#endif
#if OPT_ONLINEHELP
		,"redo changes made to a buffer, after they have been undone"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unabbr) = {
	INIT_UNION(unabbr),
	EXRCOK|BANG|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unabbr"
#endif
#if OPT_ONLINEHELP
		,"delete an abbreviation"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_reptc_func) = {
	INIT_UNION(reptc_func),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"reptc_func"
#endif
#if OPT_ONLINEHELP
		,"supply a numeric CNT to a command. sets CNT to 4, 16, 64, 256, etc."
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unimpl) = {
	INIT_UNION(unimpl),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unimpl"
#endif
#if OPT_ONLINEHELP
		,"place holder for the todo list"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unmark) = {
	INIT_UNION(unmark),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unmark"
#endif
#if OPT_ONLINEHELP
		,"clear the \"modified\" status of a buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unmap) = {
	INIT_UNION(unmap),
	EXRCOK|BANG|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unmap"
#endif
#if OPT_ONLINEHELP
		,"delete a command-mode mapping"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unmap_bang) = {
	INIT_UNION(unmap_bang),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unmap_bang"
#endif
#if OPT_ONLINEHELP
		,"delete an insert-mode mapping"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_unmap_system) = {
	INIT_UNION(unmap_system),
	EXRCOK|EXTRA
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"unmap_system"
#endif
#if OPT_ONLINEHELP
		,"delete a system function-key mapping"
#endif
 };
#if OPT_TAGS
	DECL_EXTERN_CONST(CMDFUNC f_untagpop) = {
	INIT_UNION(untagpop),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"untagpop"
#endif
#if OPT_ONLINEHELP
		,"restore cursor and buffer to location before last tag lookup"
#endif
 };
#endif
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_upscreen) = {
	INIT_UNION(upscreen),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"upscreen"
#endif
#if OPT_ONLINEHELP
		,"force the screen to be updated; flushes all pending output"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_usebuffer) = {
	INIT_UNION(usebuffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"usebuffer"
#endif
#if OPT_ONLINEHELP
		,"switch to the given buffer; will not look for a file by that name"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_edit_buffer) = {
	INIT_UNION(edit_buffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"edit_buffer"
#endif
#if OPT_ONLINEHELP
		,"make or switch to the given buffer"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_popup_buffer) = {
	INIT_UNION(popup_buffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"popup_buffer"
#endif
#if OPT_ONLINEHELP
		,"open window for the given buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_popdown_buffer) = {
	INIT_UNION(popdown_buffer),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"popdown_buffer"
#endif
#if OPT_ONLINEHELP
		,"close all windows for the given buffer"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_usekreg) = {
	INIT_UNION(usekreg),
	REDO|USEREG
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"usekreg"
#endif
#if OPT_ONLINEHELP
		,"name a register, for use with a following command which references it"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_userbeep) = {
	INIT_UNION(userbeep),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"userbeep"
#endif
#if OPT_ONLINEHELP
		,"force the terminal to ring (or flash, if \"set flash\" is active)"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_visual) = {
	INIT_UNION(visual),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"visual"
#endif
#if OPT_ONLINEHELP
		,"switch from non-existent exile mode back to visual mode.  unimplemented"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vglobals) = {
	INIT_UNION(vglobals),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vglobals"
#endif
#if OPT_ONLINEHELP
		,""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_viewfile) = {
	INIT_UNION(viewfile),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"viewfile"
#endif
#if OPT_ONLINEHELP
		,"bring given file or existing buffer into window, mark it \"view-only\""
#endif
 };
#if OPT_SHELL
	DECL_EXTERN_CONST(CMDFUNC f_vl_dirs) = {
	INIT_UNION(vl_dirs),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_dirs"
#endif
#if OPT_ONLINEHELP
		,"list internal directory stack in scratch buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_dirs_add) = {
	INIT_UNION(vl_dirs_add),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_dirs_add"
#endif
#if OPT_ONLINEHELP
		,"add a dir to DirStack[top - 1]; cwd is unaffected"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_vl_dirs_clear) = {
	INIT_UNION(vl_dirs_clear),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"vl_dirs_clear"
#endif
#if OPT_ONLINEHELP
		,"clear internal directory stack; cwd is unaffected"
#endif
 };
#endif
#if SYS_WINNT&&defined(VILE_OLE)
	DECL_EXTERN_CONST(CMDFUNC f_waitfile) = {
	INIT_UNION(waitfile),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"waitfile"
#endif
#if OPT_ONLINEHELP
		,"wait for file to grow larger than 0 bytes, timeout specified as arg"
#endif
 };
#endif
#if OPT_SHOW_WHICH
	DECL_EXTERN_CONST(CMDFUNC f_which_exec) = {
	INIT_UNION(which_exec),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"which_exec"
#endif
#if OPT_ONLINEHELP
		,"show which file would be exec'd from $PATH + $libdir-path, CNT for popup"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_which_source) = {
	INIT_UNION(which_source),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"which_source"
#endif
#if OPT_ONLINEHELP
		,"show which file would be source'd from $startup-path, CNT for popup"
#endif
 };
#endif
#if SYS_WINNT
	DECL_EXTERN_CONST(CMDFUNC f_purge_recent_files) = {
	INIT_UNION(purge_recent_files),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"purge_recent_files"
#endif
#if OPT_ONLINEHELP
		,"purge winvile's recent file list"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_purge_recent_folders) = {
	INIT_UNION(purge_recent_folders),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"purge_recent_folders"
#endif
#if OPT_ONLINEHELP
		,"purge winvile's recent folder list"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_wincd) = {
	INIT_UNION(wincd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"wincd"
#endif
#if OPT_ONLINEHELP
		,"graphical CD"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_winopen_nocd) = {
	INIT_UNION(winopen_nocd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"winopen_nocd"
#endif
#if OPT_ONLINEHELP
		,"launch Windows common dialog box to open file(s), CWD is unmodified"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_winopen) = {
	INIT_UNION(winopen),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"winopen"
#endif
#if OPT_ONLINEHELP
		,"launch Windows common dialog box to open file(s), CWD changes as side effect"
#endif
 };
#endif
#if SYS_WINNT&&DISP_NTWIN
	DECL_EXTERN_CONST(CMDFUNC f_winpg_setup) = {
	INIT_UNION(winpg_setup),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"winpg_setup"
#endif
#if OPT_ONLINEHELP
		,"launch Windows common page setup dialog"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_winprint) = {
	INIT_UNION(winprint),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"winprint"
#endif
#if OPT_ONLINEHELP
		,"print current buffer or selection"
#endif
 };
#endif
#if SYS_WINNT
	DECL_EXTERN_CONST(CMDFUNC f_winsave_nocd) = {
	INIT_UNION(winsave_nocd),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"winsave_nocd"
#endif
#if OPT_ONLINEHELP
		,"launch Windows common dialog box to save current buffer, CWD is unmodified"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_winsave) = {
	INIT_UNION(winsave),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"winsave"
#endif
#if OPT_ONLINEHELP
		,"launch Windows common dialog box to save current buffer, CWD changes as side effect"
#endif
 };
#endif
#if SYS_WINNT&&DISP_NTWIN
	DECL_EXTERN_CONST(CMDFUNC f_ResetRGBPalette) = {
	INIT_UNION(ResetRGBPalette),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"ResetRGBPalette"
#endif
#if OPT_ONLINEHELP
		,"reset palette (see set-rgb-palette)"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_SetRGBPalette) = {
	INIT_UNION(SetRGBPalette),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"SetRGBPalette"
#endif
#if OPT_ONLINEHELP
		,"set palette with parameters colornum red green blue"
#endif
 };
#endif
#if OPT_WORDCOUNT
	DECL_EXTERN_CONST(CMDFUNC f_wordcount) = {
	INIT_UNION(wordcount),
	RANGE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"wordcount"
#endif
#if OPT_ONLINEHELP
		,"count words, lines, and chars in the region"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_writeallbuffers) = {
	INIT_UNION(writeallbuffers),
	BANG|VI_NL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"writeallbuffers"
#endif
#if OPT_ONLINEHELP
		,"attempt to write all buffers whether or not marked \"modified\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_writeallchanged) = {
	INIT_UNION(writeallchanged),
	BANG|VI_NL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"writeallchanged"
#endif
#if OPT_ONLINEHELP
		,"attempt to write any buffers which are marked \"modified\""
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_writequit) = {
	INIT_UNION(writequit),
	VI_NL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"writequit"
#endif
#if OPT_ONLINEHELP
		,"write the current buffer, and quit if no other buffers are modified"
#endif
 };
#if !SMALLER
	DECL_EXTERN_CONST(CMDFUNC f_wrapword) = {
	INIT_UNION(wrapword),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"wrapword"
#endif
#if OPT_ONLINEHELP
		,"split line in two at first preceding word break.  give CNT to trim blanks."
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_writemsg) = {
	INIT_UNION(writemsg),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"writemsg"
#endif
#if OPT_ONLINEHELP
		,"put a message on the message line"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_yankline) = {
	INIT_UNION(yankline),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"yankline"
#endif
#if OPT_ONLINEHELP
		,"get the current line into the given named or unnamed register"
#endif
 };
#if OPT_XTERM||DISP_X11
	DECL_EXTERN_CONST(CMDFUNC f_mouse_motion) = {
	INIT_UNION(mouse_motion),
	ABSM|MOTION
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"mouse_motion"
#endif
#if OPT_ONLINEHELP
		,"dummy command to support mouse movements internally"
#endif
 };
#endif
#if DISP_X11
	DECL_EXTERN_CONST(CMDFUNC f_copy_to_clipboard) = {
	INIT_UNION(copy_to_clipboard),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"copy_to_clipboard"
#endif
#if OPT_ONLINEHELP
		,"copies the currently highlighted selection to the cut buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_paste_from_clipboard) = {
	INIT_UNION(paste_from_clipboard),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"paste_from_clipboard"
#endif
#if OPT_ONLINEHELP
		,"pastes the contents of the cut buffer"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_paste_from_primary) = {
	INIT_UNION(paste_from_primary),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"paste_from_primary"
#endif
#if OPT_ONLINEHELP
		,"pastes the contents of the primary selection"
#endif
 };
#endif
#if (OPT_XTERM>=3)
	DECL_EXTERN_CONST(CMDFUNC f_xterm_mouse_t) = {
	INIT_UNION(xterm_mouse_t),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"xterm_mouse_t"
#endif
#if OPT_ONLINEHELP
		,"dummy command to support xterm mouse operation"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_xterm_mouse_T) = {
	INIT_UNION(xterm_mouse_T),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"xterm_mouse_T"
#endif
#if OPT_ONLINEHELP
		,"dummy command to support xterm mouse operation"
#endif
 };
#endif
	DECL_EXTERN_CONST(CMDFUNC f_zzquit) = {
	INIT_UNION(zzquit),
	BANG|VI_NL
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"zzquit"
#endif
#if OPT_ONLINEHELP
		,"if repeated, leave the editor, writing modified buffers as needed"
#endif
 };
#if SYS_WINNT
	DECL_EXTERN_CONST(CMDFUNC f_cbrdcpy_unnamed) = {
	INIT_UNION(cbrdcpy_unnamed),
	NONE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbrdcpy_unnamed"
#endif
#if OPT_ONLINEHELP
		,"copies the unnamed register selection to the windows clipboard"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_cbrdcut) = {
	INIT_UNION(cbrdcut),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbrdcut"
#endif
#if OPT_ONLINEHELP
		,"cut the current selection to the unnamed register and windows clipboard"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_cbrdpaste) = {
	INIT_UNION(cbrdpaste),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"cbrdpaste"
#endif
#if OPT_ONLINEHELP
		,"paste the windows clipboard contents"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_opercbrdcpy) = {
	INIT_UNION(opercbrdcpy),
	OPER|RANGE|NOMOVE
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"opercbrdcpy"
#endif
#if OPT_ONLINEHELP
		,"copies the specified region to the windows clipboard"
#endif
 };
	DECL_EXTERN_CONST(CMDFUNC f_windeltxtsel) = {
	INIT_UNION(windeltxtsel),
	REDO|UNDO
#if OPT_MACRO_ARGS
		,0
#endif
#if OPT_TRACE
		,"windeltxtsel"
#endif
#if OPT_ONLINEHELP
		,"delete the current text selection to the unnamed register"
#endif
 };
#endif

#else

extern const CMDFUNC f_abbrev;
extern const CMDFUNC f_altbuff;
extern const CMDFUNC f_append;
extern const CMDFUNC f_append_i;
#if !SMALLER
extern const CMDFUNC f_appstring;
extern const CMDFUNC f_appnumber;
#endif
extern const CMDFUNC f_appendeol;
extern const CMDFUNC f_backchar;
extern const CMDFUNC f_backchar_to_bol;
extern const CMDFUNC f_backdelchar;
#if !SMALLER
extern const CMDFUNC f_backhunt;
#endif
extern const CMDFUNC f_backhpage;
extern const CMDFUNC f_backline;
extern const CMDFUNC f_backbline;
extern const CMDFUNC f_backpage;
extern const CMDFUNC f_back_row;
extern const CMDFUNC f_backword;
extern const CMDFUNC f_backviword;
extern const CMDFUNC f_backsearch;
extern const CMDFUNC f_bcsrch;
extern const CMDFUNC f_bcsrch_to;
#if OPT_REBIND
extern const CMDFUNC f_bindkey;
extern const CMDFUNC f_bind_i_key;
extern const CMDFUNC f_bind_c_key;
extern const CMDFUNC f_bind_s_key;
#endif
#if OPT_SHELL
extern const CMDFUNC f_bktoshell;
extern const CMDFUNC f_vl_chdir;
#endif
extern const CMDFUNC f_cntl_x_func;
extern const CMDFUNC f_chgchar;
extern const CMDFUNC f_chgline;
extern const CMDFUNC f_chgtoeol;
#if OPT_HILITEMATCH
extern const CMDFUNC f_clear_match_attrs;
#endif
extern const CMDFUNC f_clrmes;
#if OPT_FINDERR
extern const CMDFUNC f_comp_err_exps;
extern const CMDFUNC f_show_err_regex;
#endif
extern const CMDFUNC f_consearch;
extern const CMDFUNC f_opercopy;
extern const CMDFUNC f_kbd_mac_startstop;
extern const CMDFUNC f_kbd_mac_exec;
extern const CMDFUNC f_kbd_mac_save;
#if OPT_EXEC_MACROS>0
extern const CMDFUNC f_cbuf1;
#endif
#if OPT_EXEC_MACROS>1
extern const CMDFUNC f_cbuf2;
#endif
#if OPT_EXEC_MACROS>2
extern const CMDFUNC f_cbuf3;
#endif
#if OPT_EXEC_MACROS>3
extern const CMDFUNC f_cbuf4;
#endif
#if OPT_EXEC_MACROS>4
extern const CMDFUNC f_cbuf5;
#endif
#if OPT_EXEC_MACROS>5
extern const CMDFUNC f_cbuf6;
#endif
#if OPT_EXEC_MACROS>6
extern const CMDFUNC f_cbuf7;
#endif
#if OPT_EXEC_MACROS>7
extern const CMDFUNC f_cbuf8;
#endif
#if OPT_EXEC_MACROS>8
extern const CMDFUNC f_cbuf9;
#endif
#if OPT_EXEC_MACROS>9
extern const CMDFUNC f_cbuf10;
#endif
#if OPT_EXEC_MACROS>10
extern const CMDFUNC f_cbuf11;
#endif
#if OPT_EXEC_MACROS>11
extern const CMDFUNC f_cbuf12;
#endif
#if OPT_EXEC_MACROS>12
extern const CMDFUNC f_cbuf13;
#endif
#if OPT_EXEC_MACROS>13
extern const CMDFUNC f_cbuf14;
#endif
#if OPT_EXEC_MACROS>14
extern const CMDFUNC f_cbuf15;
#endif
#if OPT_EXEC_MACROS>15
extern const CMDFUNC f_cbuf16;
#endif
#if OPT_EXEC_MACROS>16
extern const CMDFUNC f_cbuf17;
#endif
#if OPT_EXEC_MACROS>17
extern const CMDFUNC f_cbuf18;
#endif
#if OPT_EXEC_MACROS>18
extern const CMDFUNC f_cbuf19;
#endif
#if OPT_EXEC_MACROS>19
extern const CMDFUNC f_cbuf20;
#endif
#if OPT_EXEC_MACROS>20
extern const CMDFUNC f_cbuf21;
#endif
#if OPT_EXEC_MACROS>21
extern const CMDFUNC f_cbuf22;
#endif
#if OPT_EXEC_MACROS>22
extern const CMDFUNC f_cbuf23;
#endif
#if OPT_EXEC_MACROS>23
extern const CMDFUNC f_cbuf24;
#endif
#if OPT_EXEC_MACROS>24
extern const CMDFUNC f_cbuf25;
#endif
#if OPT_EXEC_MACROS>25
extern const CMDFUNC f_cbuf26;
#endif
#if OPT_EXEC_MACROS>26
extern const CMDFUNC f_cbuf27;
#endif
#if OPT_EXEC_MACROS>27
extern const CMDFUNC f_cbuf28;
#endif
#if OPT_EXEC_MACROS>28
extern const CMDFUNC f_cbuf29;
#endif
#if OPT_EXEC_MACROS>29
extern const CMDFUNC f_cbuf30;
#endif
#if OPT_EXEC_MACROS>30
extern const CMDFUNC f_cbuf31;
#endif
#if OPT_EXEC_MACROS>31
extern const CMDFUNC f_cbuf32;
#endif
#if OPT_EXEC_MACROS>32
extern const CMDFUNC f_cbuf33;
#endif
#if OPT_EXEC_MACROS>33
extern const CMDFUNC f_cbuf34;
#endif
#if OPT_EXEC_MACROS>34
extern const CMDFUNC f_cbuf35;
#endif
#if OPT_EXEC_MACROS>35
extern const CMDFUNC f_cbuf36;
#endif
#if OPT_EXEC_MACROS>36
extern const CMDFUNC f_cbuf37;
#endif
#if OPT_EXEC_MACROS>37
extern const CMDFUNC f_cbuf38;
#endif
#if OPT_EXEC_MACROS>38
extern const CMDFUNC f_cbuf39;
#endif
#if OPT_EXEC_MACROS>39
extern const CMDFUNC f_cbuf40;
#endif
#if OPT_EXEC_MACROS>40
extern const CMDFUNC f_cbuf41;
#endif
#if OPT_EXEC_MACROS>41
extern const CMDFUNC f_cbuf42;
#endif
#if OPT_EXEC_MACROS>42
extern const CMDFUNC f_cbuf43;
#endif
#if OPT_EXEC_MACROS>43
extern const CMDFUNC f_cbuf44;
#endif
#if OPT_EXEC_MACROS>44
extern const CMDFUNC f_cbuf45;
#endif
#if OPT_EXEC_MACROS>45
extern const CMDFUNC f_cbuf46;
#endif
#if OPT_EXEC_MACROS>46
extern const CMDFUNC f_cbuf47;
#endif
#if OPT_EXEC_MACROS>47
extern const CMDFUNC f_cbuf48;
#endif
#if OPT_MAJORMODE
extern const CMDFUNC f_define_mode;
extern const CMDFUNC f_define_submode;
#endif
#if OPT_COLOR_SCHEMES
extern const CMDFUNC f_define_scheme;
#endif
extern const CMDFUNC f_delwind;
extern const CMDFUNC f_forceblank;
extern const CMDFUNC f_delglobmode;
extern const CMDFUNC f_dellocmode;
extern const CMDFUNC f_deltoeol;
#if OPT_REBIND
extern const CMDFUNC f_desbind;
extern const CMDFUNC f_des_i_bind;
extern const CMDFUNC f_des_c_bind;
extern const CMDFUNC f_des_s_bind;
extern const CMDFUNC f_des_keynames;
#endif
#if OPT_SHOW_COLORS
extern const CMDFUNC f_descolors;
#endif
#if OPT_REBIND
extern const CMDFUNC f_desmotions;
extern const CMDFUNC f_desopers;
#endif
#if OPT_COLOR_SCHEMES
extern const CMDFUNC f_desschemes;
#endif
#if OPT_SHOW_CTYPE
extern const CMDFUNC f_desprint;
#endif
#if OPT_REBIND
extern const CMDFUNC f_dessubstr;
extern const CMDFUNC f_desfunc;
extern const CMDFUNC f_deskey;
extern const CMDFUNC f_des_i_key;
extern const CMDFUNC f_des_c_key;
extern const CMDFUNC f_des_s_key;
#endif
extern const CMDFUNC f_dotcmdplay;
#if OPT_EVAL
extern const CMDFUNC f_des_amp_funcs;
extern const CMDFUNC f_des_dlr_vars;
extern const CMDFUNC f_evaluate;
#endif
extern const CMDFUNC f_ex;
#if !SMALLER
extern const CMDFUNC f_execbuf;
#endif
extern const CMDFUNC f_execfile;
#if OPT_HYPERTEXT
extern const CMDFUNC f_exechypercmd;
extern const CMDFUNC f_showhypercmd;
#endif
extern const CMDFUNC f_execkreg;
#if OPT_PROCEDURES
extern const CMDFUNC f_execproc;
#endif
extern const CMDFUNC f_enlargewind;
extern const CMDFUNC f_esc_func;
#if SYS_UNIX
extern const CMDFUNC f_flow_control_enable;
#endif
extern const CMDFUNC f_fcsrch;
extern const CMDFUNC f_fcsrch_to;
extern const CMDFUNC f_filefind;
extern const CMDFUNC f_fileread;
extern const CMDFUNC f_vl_filename;
#if !SMALLER
extern const CMDFUNC f_filesave;
#endif
extern const CMDFUNC f_filewrite;
#if OPT_SHELL
extern const CMDFUNC f_vile_filter;
#endif
#if OPT_FINDERR
extern const CMDFUNC f_finderr;
extern const CMDFUNC f_finderrbuf;
#endif
extern const CMDFUNC f_firstbuffer;
extern const CMDFUNC f_firstnonwhite;
#if OPT_ISRCH
extern const CMDFUNC f_fisearch;
#endif
extern const CMDFUNC f_flipchar;
extern const CMDFUNC f_forwdelchar;
extern const CMDFUNC f_forwhpage;
extern const CMDFUNC f_forwchar;
extern const CMDFUNC f_forwchar_to_eol;
extern const CMDFUNC f_forwpage;
extern const CMDFUNC f_forw_row;
extern const CMDFUNC f_forwline;
extern const CMDFUNC f_forwbline;
extern const CMDFUNC f_forwword;
extern const CMDFUNC f_forwviword;
extern const CMDFUNC f_forwendw;
extern const CMDFUNC f_forwviendw;
#if !SMALLER
extern const CMDFUNC f_forwhunt;
#endif
extern const CMDFUNC f_forwsearch;
#if OPT_CFENCE
extern const CMDFUNC f_matchfence;
extern const CMDFUNC f_matchfenceback;
#endif
extern const CMDFUNC f_globals;
extern const CMDFUNC f_godotplus;
extern const CMDFUNC f_gomark;
extern const CMDFUNC f_gotobop;
extern const CMDFUNC f_gotoeop;
#if !SMALLER
extern const CMDFUNC f_gotobob;
extern const CMDFUNC f_gotoeob;
#endif
extern const CMDFUNC f_gotobol;
extern const CMDFUNC f_gotoeol;
extern const CMDFUNC f_gotobos;
extern const CMDFUNC f_gotomos;
extern const CMDFUNC f_gotoeos;
extern const CMDFUNC f_gotobosec;
extern const CMDFUNC f_gotoeosec;
extern const CMDFUNC f_gotobosent;
extern const CMDFUNC f_gotoeosent;
#if OPT_TAGS
extern const CMDFUNC f_gototag;
#endif
#if !SMALLER
extern const CMDFUNC f_gotochr;
extern const CMDFUNC f_gotopct;
#endif
extern const CMDFUNC f_gotocol;
extern const CMDFUNC f_gotoline;
extern const CMDFUNC f_golinenmmark;
extern const CMDFUNC f_goexactnmmark;
extern const CMDFUNC f_gorectnmmark;
extern const CMDFUNC f_vl_help;
extern const CMDFUNC f_histbuff;
extern const CMDFUNC f_histbuff_to_current_window;
extern const CMDFUNC f_insert;
extern const CMDFUNC f_insert_no_aindent;
extern const CMDFUNC f_insertbol;
extern const CMDFUNC f_insfile;
#if !SMALLER
extern const CMDFUNC f_insspace;
extern const CMDFUNC f_insstring;
extern const CMDFUNC f_insnumber;
#endif
extern const CMDFUNC f_joinlines;
#if !SMALLER
extern const CMDFUNC f_for_buffers;
#endif
extern const CMDFUNC f_killbuffer;
extern const CMDFUNC f_showlength;
#if !SMALLER
extern const CMDFUNC f_lastnonwhite;
#endif
extern const CMDFUNC f_listbuffers;
extern const CMDFUNC f_vl_set_args;
extern const CMDFUNC f_vl_set_args2;
#if OPT_HISTORY
extern const CMDFUNC f_showhistory;
#endif
extern const CMDFUNC f_lineputafter;
extern const CMDFUNC f_lineputbefore;
extern const CMDFUNC f_rectputafter;
extern const CMDFUNC f_rectputbefore;
extern const CMDFUNC f_lineundo;
extern const CMDFUNC f_loadkreg;
#if OPT_PLUGIN
extern const CMDFUNC f_loadplugin;
#endif
#if OPT_SHOW_REGS
extern const CMDFUNC f_showkreg;
#endif
#if OPT_SHOW_MAPS
extern const CMDFUNC f_sysmap;
#endif
extern const CMDFUNC f_map;
extern const CMDFUNC f_map_bang;
#if OPT_MENUS
extern const CMDFUNC f_gui_hide_menus;
extern const CMDFUNC f_gui_remove_menus;
extern const CMDFUNC f_gui_show_menus;
extern const CMDFUNC f_vlmenu_load;
#endif
#if OPT_TAGS
extern const CMDFUNC f_nexttag;
#endif
extern const CMDFUNC f_newprocessgroup;
extern const CMDFUNC f_noremap;
extern const CMDFUNC f_noremap_bang;
extern const CMDFUNC f_cntl_a_func;
extern const CMDFUNC f_mvdnnxtwind;
extern const CMDFUNC f_mvupnxtwind;
extern const CMDFUNC f_mvdnwind;
extern const CMDFUNC f_mvupwind;
extern const CMDFUNC f_mvrightwind;
extern const CMDFUNC f_mvleftwind;
extern const CMDFUNC f_nextbuffer;
extern const CMDFUNC f_namebuffer;
extern const CMDFUNC f_name_a_buffer;
#if !SMALLER
extern const CMDFUNC f_newline;
#endif
extern const CMDFUNC f_newlength;
extern const CMDFUNC f_newwidth;
extern const CMDFUNC f_nextwind;
extern const CMDFUNC f_nullproc;
extern const CMDFUNC f_namedcmd;
extern const CMDFUNC f_openup;
#if !SMALLER
extern const CMDFUNC f_openup_i;
#endif
extern const CMDFUNC f_openup_no_aindent;
extern const CMDFUNC f_opendown;
extern const CMDFUNC f_opendown_no_aindent;
extern const CMDFUNC f_operopenrect;
#if OPT_SELECTIONS
extern const CMDFUNC f_operattrbold;
extern const CMDFUNC f_operattrcaseq;
extern const CMDFUNC f_operattrencode;
#endif
#if OPT_SELECTIONS&&OPT_FILTER
extern const CMDFUNC f_operattrdirect;
#endif
#if OPT_SELECTIONS&&OPT_SHELL
extern const CMDFUNC f_operattrfilter;
#endif
#if OPT_HYPERTEXT
extern const CMDFUNC f_operattrhc;
#endif
#if OPT_SELECTIONS
extern const CMDFUNC f_operattrital;
extern const CMDFUNC f_operattrno;
extern const CMDFUNC f_operattrrev;
extern const CMDFUNC f_operattrul;
#endif
extern const CMDFUNC f_operchg;
#if !SMALLER
extern const CMDFUNC f_operchg_i;
#endif
extern const CMDFUNC f_operdetab;
extern const CMDFUNC f_oper_l_detab;
extern const CMDFUNC f_operentab;
extern const CMDFUNC f_oper_l_entab;
extern const CMDFUNC f_opermove;
extern const CMDFUNC f_operlinechg;
extern const CMDFUNC f_operdel;
extern const CMDFUNC f_operjoin;
extern const CMDFUNC f_operjoin_x;
extern const CMDFUNC f_operlinedel;
#if OPT_SHELL
extern const CMDFUNC f_operfilter;
#endif
#if OPT_FORMAT
extern const CMDFUNC f_operformat;
#endif
extern const CMDFUNC f_operflip;
extern const CMDFUNC f_operglobals;
extern const CMDFUNC f_opervglobals;
extern const CMDFUNC f_operlower;
extern const CMDFUNC f_operlist;
extern const CMDFUNC f_opernumber;
extern const CMDFUNC f_operprint;
extern const CMDFUNC f_operpprint;
#if OPT_SELECTIONS
extern const CMDFUNC f_operselect;
#endif
extern const CMDFUNC f_operupper;
extern const CMDFUNC f_operlshift;
extern const CMDFUNC f_operrshift;
extern const CMDFUNC f_opersubst;
extern const CMDFUNC f_opersubstall;
extern const CMDFUNC f_opertrim;
extern const CMDFUNC f_operblank;
extern const CMDFUNC f_operyank;
extern const CMDFUNC f_operlineyank;
extern const CMDFUNC f_opersubstagain;
extern const CMDFUNC f_opertransf;
extern const CMDFUNC f_operwrite;
#if OPT_SELECTIONS
extern const CMDFUNC f_oper_wrenc;
#endif
extern const CMDFUNC f_overwritechars;
#if !SMALLER
extern const CMDFUNC f_overwstring;
extern const CMDFUNC f_overwnumber;
#endif
extern const CMDFUNC f_onlywind;
#if OPT_PERL
extern const CMDFUNC f_perl;
extern const CMDFUNC f_perldo;
#endif
#if OPT_SHELL
extern const CMDFUNC f_popd;
#endif
extern const CMDFUNC f_poswind;
#if !SMALLER
extern const CMDFUNC f_prevbuffer;
#endif
extern const CMDFUNC f_prevwind;
#if OPT_SHELL
extern const CMDFUNC f_pushd;
extern const CMDFUNC f_capturecmd;
#endif
extern const CMDFUNC f_putafter;
extern const CMDFUNC f_putbefore;
#if OPT_SHELL
extern const CMDFUNC f_pwd;
#endif
extern const CMDFUNC f_quit;
extern const CMDFUNC f_quithard;
extern const CMDFUNC f_quickexit;
extern const CMDFUNC f_quote_next;
extern const CMDFUNC f_vile_refresh;
#if OPT_MAJORMODE
extern const CMDFUNC f_remove_mode;
extern const CMDFUNC f_remove_submode;
#endif
#if OPT_COLOR_SCHEMES
extern const CMDFUNC f_remove_scheme;
#endif
#if !SMALLER
extern const CMDFUNC f_reposition;
#endif
extern const CMDFUNC f_rep_csrch;
extern const CMDFUNC f_replacechar;
#if OPT_SHELL
extern const CMDFUNC f_respawn;
#endif
#if !SMALLER
extern const CMDFUNC f_resize;
extern const CMDFUNC f_restwnd;
#endif
#if OPT_MAJORMODE
extern const CMDFUNC f_reset_majormode;
#endif
extern const CMDFUNC f_rev_csrch;
#if OPT_ISRCH
extern const CMDFUNC f_risearch;
#endif
extern const CMDFUNC f_revsearch;
#if OPT_SELECTIONS&&OPT_SEL_YANK
extern const CMDFUNC f_sel_all;
#endif
#if OPT_SELECTIONS
extern const CMDFUNC f_sel_clear;
extern const CMDFUNC f_sel_motion;
#endif
extern const CMDFUNC f_scrforwsearch;
extern const CMDFUNC f_scrbacksearch;
extern const CMDFUNC f_scrsearchpat;
#if OPT_SHOW_CTYPE
extern const CMDFUNC f_set_charclass;
extern const CMDFUNC f_unset_charclass;
extern const CMDFUNC f_reset_charclasses;
#endif
#if OPT_DOSFILES
extern const CMDFUNC f_set_rs_crlf;
extern const CMDFUNC f_set_rs_lf;
extern const CMDFUNC f_set_rs_cr;
#endif
extern const CMDFUNC f_settab;
#if OPT_REBIND&&OPT_TERMCHRS
extern const CMDFUNC f_set_termchrs;
#endif
#if !SMALLER
extern const CMDFUNC f_set_window;
#endif
#if OPT_REBIND&&OPT_TERMCHRS
extern const CMDFUNC f_show_termchrs;
#endif
#if !SMALLER
extern const CMDFUNC f_show_undostk;
#endif
#if OPT_SHELL
extern const CMDFUNC f_spawncli;
#endif
#if !SMALLER
extern const CMDFUNC f_savewnd;
#endif
extern const CMDFUNC f_scrnextup;
extern const CMDFUNC f_scrnextdw;
extern const CMDFUNC f_setfillcol;
#if OPT_SHELL&&defined(HAVE_PUTENV)
extern const CMDFUNC f_set_envvar;
#endif
#if OPT_SELECTIONS
extern const CMDFUNC f_multimotion;
extern const CMDFUNC f_multimotionfullline;
extern const CMDFUNC f_multimotionrectangle;
#endif
#if OPT_ENCRYPT
extern const CMDFUNC f_vl_setkey;
#endif
extern const CMDFUNC f_setlocmode;
extern const CMDFUNC f_setglobmode;
extern const CMDFUNC f_setnmmark;
#if OPT_EVAL
extern const CMDFUNC f_setvar;
extern const CMDFUNC f_unsetvar;
#endif
extern const CMDFUNC f_showcpos;
extern const CMDFUNC f_listmodes;
#if OPT_MAJORMODE
extern const CMDFUNC f_list_majormodes;
#endif
#if OPT_SHOW_EVAL
extern const CMDFUNC f_listvars;
#endif
extern const CMDFUNC f_showversion;
#if OPT_SHOW_MARKS
extern const CMDFUNC f_showmarks;
#endif
#if SYS_MSDOS&&(CC_TURBO||CC_WATCOM||CC_DJGPP)
extern const CMDFUNC f_showmemory;
#endif
#if OPT_SHOW_TAGS
extern const CMDFUNC f_showtagstack;
#endif
extern const CMDFUNC f_shrinkwind;
extern const CMDFUNC f_vl_source;
#if OPT_SHELL
extern const CMDFUNC f_vl_spawn;
#endif
extern const CMDFUNC f_poundc_func;
extern const CMDFUNC f_splitwind;
extern const CMDFUNC f_store_macro;
#if OPT_PROCEDURES
extern const CMDFUNC f_store_proc;
extern const CMDFUNC f_store_op;
#endif
extern const CMDFUNC f_subst_again;
#if SYS_WINNT&&defined(VILE_OLE)
extern const CMDFUNC f_syncfile;
#endif
#if SYS_WINNT
extern const CMDFUNC f_swapcbrdkeys;
#endif
extern const CMDFUNC f_togglelistbuffers;
#if !SMALLER
extern const CMDFUNC f_twiddle;
#endif
#if OPT_REBIND
extern const CMDFUNC f_unbindkey;
extern const CMDFUNC f_unbind_i_key;
extern const CMDFUNC f_unbind_c_key;
extern const CMDFUNC f_unbind_s_key;
#endif
extern const CMDFUNC f_undo;
extern const CMDFUNC f_inf_undo;
extern const CMDFUNC f_backundo;
extern const CMDFUNC f_forwredo;
extern const CMDFUNC f_unabbr;
extern const CMDFUNC f_reptc_func;
extern const CMDFUNC f_unimpl;
extern const CMDFUNC f_unmark;
extern const CMDFUNC f_unmap;
extern const CMDFUNC f_unmap_bang;
extern const CMDFUNC f_unmap_system;
#if OPT_TAGS
extern const CMDFUNC f_untagpop;
#endif
#if !SMALLER
extern const CMDFUNC f_upscreen;
#endif
extern const CMDFUNC f_usebuffer;
extern const CMDFUNC f_edit_buffer;
#if !SMALLER
extern const CMDFUNC f_popup_buffer;
extern const CMDFUNC f_popdown_buffer;
#endif
extern const CMDFUNC f_usekreg;
#if !SMALLER
extern const CMDFUNC f_userbeep;
#endif
extern const CMDFUNC f_visual;
extern const CMDFUNC f_vglobals;
extern const CMDFUNC f_viewfile;
#if OPT_SHELL
extern const CMDFUNC f_vl_dirs;
extern const CMDFUNC f_vl_dirs_add;
extern const CMDFUNC f_vl_dirs_clear;
#endif
#if SYS_WINNT&&defined(VILE_OLE)
extern const CMDFUNC f_waitfile;
#endif
#if OPT_SHOW_WHICH
extern const CMDFUNC f_which_exec;
extern const CMDFUNC f_which_source;
#endif
#if SYS_WINNT
extern const CMDFUNC f_purge_recent_files;
extern const CMDFUNC f_purge_recent_folders;
extern const CMDFUNC f_wincd;
extern const CMDFUNC f_winopen_nocd;
extern const CMDFUNC f_winopen;
#endif
#if SYS_WINNT&&DISP_NTWIN
extern const CMDFUNC f_winpg_setup;
extern const CMDFUNC f_winprint;
#endif
#if SYS_WINNT
extern const CMDFUNC f_winsave_nocd;
extern const CMDFUNC f_winsave;
#endif
#if SYS_WINNT&&DISP_NTWIN
extern const CMDFUNC f_ResetRGBPalette;
extern const CMDFUNC f_SetRGBPalette;
#endif
#if OPT_WORDCOUNT
extern const CMDFUNC f_wordcount;
#endif
extern const CMDFUNC f_writeallbuffers;
extern const CMDFUNC f_writeallchanged;
extern const CMDFUNC f_writequit;
#if !SMALLER
extern const CMDFUNC f_wrapword;
extern const CMDFUNC f_writemsg;
#endif
extern const CMDFUNC f_yankline;
#if OPT_XTERM||DISP_X11
extern const CMDFUNC f_mouse_motion;
#endif
#if DISP_X11
extern const CMDFUNC f_copy_to_clipboard;
extern const CMDFUNC f_paste_from_clipboard;
extern const CMDFUNC f_paste_from_primary;
#endif
#if (OPT_XTERM>=3)
extern const CMDFUNC f_xterm_mouse_t;
extern const CMDFUNC f_xterm_mouse_T;
#endif
extern const CMDFUNC f_zzquit;
#if SYS_WINNT
extern const CMDFUNC f_cbrdcpy_unnamed;
extern const CMDFUNC f_cbrdcut;
extern const CMDFUNC f_cbrdpaste;
extern const CMDFUNC f_opercbrdcpy;
extern const CMDFUNC f_windeltxtsel;
#endif

#endif
